#
# This parser was generated with
# Parse::RecDescent version 1.967013
#

{
# GENERATE RECURSIVE DESCENT PARSER OBJECTS FROM A GRAMMAR

use 5.006;
use strict;

package TestParser::_Runtime;

use Text::Balanced qw ( extract_codeblock extract_bracketed extract_quotelike extract_delimited );

use vars qw ( $skip );

   *defskip  = \ '\s*'; # DEFAULT SEPARATOR IS OPTIONAL WHITESPACE
   $skip  = '\s*';      # UNIVERSAL SEPARATOR IS OPTIONAL WHITESPACE
my $MAXREP  = 100_000_000;  # REPETITIONS MATCH AT MOST 100,000,000 TIMES



package TestParser::_Runtime::LineCounter;


sub TIESCALAR   # ($classname, \$text, $thisparser, $prevflag)
{
    bless {
        text    => $_[1],
        parser  => $_[2],
        prev    => $_[3]?1:0,
          }, $_[0];
}

sub FETCH
{
    my $parser = $_[0]->{parser};
    my $cache = $parser->{linecounter_cache};
    my $from = $parser->{fulltextlen}-length(${$_[0]->{text}})-$_[0]->{prev}
;

    unless (exists $cache->{$from})
    {
        $parser->{lastlinenum} = $parser->{offsetlinenum}
          - TestParser::_Runtime::_linecount(substr($parser->{fulltext},$from))
          + 1;
        $cache->{$from} = $parser->{lastlinenum};
    }
    return $cache->{$from};
}

sub STORE
{
    my $parser = $_[0]->{parser};
    $parser->{offsetlinenum} -= $parser->{lastlinenum} - $_[1];
    return undef;
}

sub resync   # ($linecounter)
{
    my $self = tied($_[0]);
    die "Tried to alter something other than a LineCounter\n"
        unless $self =~ /TestParser::_Runtime::LineCounter/;

    my $parser = $self->{parser};
    my $apparently = $parser->{offsetlinenum}
             - TestParser::_Runtime::_linecount(${$self->{text}})
             + 1;

    $parser->{offsetlinenum} += $parser->{lastlinenum} - $apparently;
    return 1;
}

package TestParser::_Runtime::ColCounter;

sub TIESCALAR   # ($classname, \$text, $thisparser, $prevflag)
{
    bless {
        text    => $_[1],
        parser  => $_[2],
        prev    => $_[3]?1:0,
          }, $_[0];
}

sub FETCH
{
    my $parser = $_[0]->{parser};
    my $missing = $parser->{fulltextlen}-length(${$_[0]->{text}})-$_[0]->{prev}+1;
    substr($parser->{fulltext},0,$missing) =~ m/^(.*)\Z/m;
    return length($1);
}

sub STORE
{
    die "Can't set column number via \$thiscolumn\n";
}


package TestParser::_Runtime::OffsetCounter;

sub TIESCALAR   # ($classname, \$text, $thisparser, $prev)
{
    bless {
        text    => $_[1],
        parser  => $_[2],
        prev    => $_[3]?-1:0,
          }, $_[0];
}

sub FETCH
{
    my $parser = $_[0]->{parser};
    return $parser->{fulltextlen}-length(${$_[0]->{text}})+$_[0]->{prev};
}

sub STORE
{
    die "Can't set current offset via \$thisoffset or \$prevoffset\n";
}



package TestParser::_Runtime::Rule;

sub new ($$$$$)
{
    my $class = ref($_[0]) || $_[0];
    my $name  = $_[1];
    my $owner = $_[2];
    my $line  = $_[3];
    my $replace = $_[4];

    if (defined $owner->{"rules"}{$name})
    {
        my $self = $owner->{"rules"}{$name};
        if ($replace && !$self->{"changed"})
        {
            $self->reset;
        }
        return $self;
    }
    else
    {
        return $owner->{"rules"}{$name} =
            bless
            {
                "name"     => $name,
                "prods"    => [],
                "calls"    => [],
                "changed"  => 0,
                "line"     => $line,
                "impcount" => 0,
                "opcount"  => 0,
                "vars"     => "",
            }, $class;
    }
}

sub reset($)
{
    @{$_[0]->{"prods"}} = ();
    @{$_[0]->{"calls"}} = ();
    $_[0]->{"changed"}  = 0;
    $_[0]->{"impcount"}  = 0;
    $_[0]->{"opcount"}  = 0;
    $_[0]->{"vars"}  = "";
}

sub DESTROY {}

sub hasleftmost($$)
{
    my ($self, $ref) = @_;

    my $prod;
    foreach $prod ( @{$self->{"prods"}} )
    {
        return 1 if $prod->hasleftmost($ref);
    }

    return 0;
}

sub leftmostsubrules($)
{
    my $self = shift;
    my @subrules = ();

    my $prod;
    foreach $prod ( @{$self->{"prods"}} )
    {
        push @subrules, $prod->leftmostsubrule();
    }

    return @subrules;
}

sub expected($)
{
    my $self = shift;
    my @expected = ();

    my $prod;
    foreach $prod ( @{$self->{"prods"}} )
    {
        my $next = $prod->expected();
        unless (! $next or _contains($next,@expected) )
        {
            push @expected, $next;
        }
    }

    return join ', or ', @expected;
}

sub _contains($@)
{
    my $target = shift;
    my $item;
    foreach $item ( @_ ) { return 1 if $target eq $item; }
    return 0;
}

sub addcall($$)
{
    my ( $self, $subrule ) = @_;
    unless ( _contains($subrule, @{$self->{"calls"}}) )
    {
        push @{$self->{"calls"}}, $subrule;
    }
}

sub addprod($$)
{
    my ( $self, $prod ) = @_;
    push @{$self->{"prods"}}, $prod;
    $self->{"changed"} = 1;
    $self->{"impcount"} = 0;
    $self->{"opcount"} = 0;
    $prod->{"number"} = $#{$self->{"prods"}};
    return $prod;
}

sub addvar
{
    my ( $self, $var, $parser ) = @_;
    if ($var =~ /\A\s*local\s+([%@\$]\w+)/)
    {
        $parser->{localvars} .= " $1";
        $self->{"vars"} .= "$var;\n" }
    else
        { $self->{"vars"} .= "my $var;\n" }
    $self->{"changed"} = 1;
    return 1;
}

sub addautoscore
{
    my ( $self, $code ) = @_;
    $self->{"autoscore"} = $code;
    $self->{"changed"} = 1;
    return 1;
}

sub nextoperator($)
{
    my $self = shift;
    my $prodcount = scalar @{$self->{"prods"}};
    my $opcount = ++$self->{"opcount"};
    return "_operator_${opcount}_of_production_${prodcount}_of_rule_$self->{name}";
}

sub nextimplicit($)
{
    my $self = shift;
    my $prodcount = scalar @{$self->{"prods"}};
    my $impcount = ++$self->{"impcount"};
    return "_alternation_${impcount}_of_production_${prodcount}_of_rule_$self->{name}";
}


sub code
{
    my ($self, $namespace, $parser, $check) = @_;

eval 'undef &' . $namespace . '::' . $self->{"name"} unless $parser->{saving};

    my $code =
'
# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub ' . $namespace . '::' . $self->{"name"} .  '
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"' . $self->{"name"} . '"};

    TestParser::_Runtime::_trace(q{Trying rule: [' . $self->{"name"} . ']},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{' . $self->{"name"} . '},
                  $tracelevel)
                    if defined $::RD_TRACE;

    ' . ($parser->{deferrable}
        ? 'my $def_at = @{$thisparser->{deferred}};'
        : '') .
    '
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{' . $self->expected() . '});
    $expectation->at($_[1]);
    '. ($parser->{_check}{thisoffset}?'
    my $thisoffset;
    tie $thisoffset, q{TestParser::_Runtime::OffsetCounter}, \$text, $thisparser;
    ':'') . ($parser->{_check}{prevoffset}?'
    my $prevoffset;
    tie $prevoffset, q{TestParser::_Runtime::OffsetCounter}, \$text, $thisparser, 1;
    ':'') . ($parser->{_check}{thiscolumn}?'
    my $thiscolumn;
    tie $thiscolumn, q{TestParser::_Runtime::ColCounter}, \$text, $thisparser;
    ':'') . ($parser->{_check}{prevcolumn}?'
    my $prevcolumn;
    tie $prevcolumn, q{TestParser::_Runtime::ColCounter}, \$text, $thisparser, 1;
    ':'') . ($parser->{_check}{prevline}?'
    my $prevline;
    tie $prevline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser, 1;
    ':'') . '
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    '. $self->{vars} .'
';

    my $prod;
    foreach $prod ( @{$self->{"prods"}} )
    {
        $prod->addscore($self->{autoscore},0,0) if $self->{autoscore};
        next unless $prod->checkleftmost();
        $code .= $prod->code($namespace,$self,$parser);

        $code .= $parser->{deferrable}
                ? '     splice
                @{$thisparser->{deferred}}, $def_at unless $_matched;
                  '
                : '';
    }

    $code .=
'
    unless ( $_matched || defined($score) )
    {
        ' .($parser->{deferrable}
            ? '     splice @{$thisparser->{deferred}}, $def_at;
              '
            : '') . '

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<'.TestParser::_Runtime::_matchtracemessage($self,1).' rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{' . $self->{"name"} .'},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{' . $self->{"name"} .'},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>'.TestParser::_Runtime::_matchtracemessage($self).' rule<< (return value: [} .
                      $return . q{])}, "",
                      q{' . $self->{"name"} .'},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{' . $self->{"name"} .'},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}
';

    return $code;
}

my @left;
sub isleftrec($$)
{
    my ($self, $rules) = @_;
    my $root = $self->{"name"};
    @left = $self->leftmostsubrules();
    my $next;
    foreach $next ( @left )
    {
        next unless defined $rules->{$next}; # SKIP NON-EXISTENT RULES
        return 1 if $next eq $root;
        my $child;
        foreach $child ( $rules->{$next}->leftmostsubrules() )
        {
            push(@left, $child)
            if ! _contains($child, @left) ;
        }
    }
    return 0;
}

package TestParser::_Runtime::Production;

sub describe ($;$)
{
    return join ' ', map { $_->describe($_[1]) or () } @{$_[0]->{items}};
}

sub new ($$;$$)
{
    my ($self, $line, $uncommit, $error) = @_;
    my $class = ref($self) || $self;

    bless
    {
        "items"    => [],
        "uncommit" => $uncommit,
        "error"    => $error,
        "line"     => $line,
        strcount   => 0,
        patcount   => 0,
        dircount   => 0,
        actcount   => 0,
    }, $class;
}

sub expected ($)
{
    my $itemcount = scalar @{$_[0]->{"items"}};
    return ($itemcount) ? $_[0]->{"items"}[0]->describe(1) : '';
}

sub hasleftmost ($$)
{
    my ($self, $ref) = @_;
    return ${$self->{"items"}}[0] eq $ref  if scalar @{$self->{"items"}};
    return 0;
}

sub isempty($)
{
    my $self = shift;
    return 0 == @{$self->{"items"}};
}

sub leftmostsubrule($)
{
    my $self = shift;

    if ( $#{$self->{"items"}} >= 0 )
    {
        my $subrule = $self->{"items"}[0]->issubrule();
        return $subrule if defined $subrule;
    }

    return ();
}

sub checkleftmost($)
{
    my @items = @{$_[0]->{"items"}};
    if (@items==1 && ref($items[0]) =~ /\ATestParser::_Runtime::Error/
        && $items[0]->{commitonly} )
    {
        TestParser::_Runtime::_warn(2,"Lone <error?> in production treated
                        as <error?> <reject>");
        TestParser::_Runtime::_hint("A production consisting of a single
                      conditional <error?> directive would
                      normally succeed (with the value zero) if the
                      rule is not 'commited' when it is
                      tried. Since you almost certainly wanted
                      '<error?> <reject>' TestParser::_Runtime
                      supplied it for you.");
        push @{$_[0]->{items}},
            TestParser::_Runtime::UncondReject->new(0,0,'<reject>');
    }
    elsif (@items==1 && ($items[0]->describe||"") =~ /<rulevar|<autoscore/)
    {
        # Do nothing
    }
    elsif (@items &&
        ( ref($items[0]) =~ /\ATestParser::_Runtime::UncondReject/
        || ($items[0]->describe||"") =~ /<autoscore/
        ))
    {
        TestParser::_Runtime::_warn(1,"Optimizing away production: [". $_[0]->describe ."]");
        my $what = $items[0]->describe =~ /<rulevar/
                ? "a <rulevar> (which acts like an unconditional <reject> during parsing)"
             : $items[0]->describe =~ /<autoscore/
                ? "an <autoscore> (which acts like an unconditional <reject> during parsing)"
                : "an unconditional <reject>";
        my $caveat = $items[0]->describe =~ /<rulevar/
                ? " after the specified variable was set up"
                : "";
        my $advice = @items > 1
                ? "However, there were also other (useless) items after the leading "
                  . $items[0]->describe
                  . ", so you may have been expecting some other behaviour."
                : "You can safely ignore this message.";
        TestParser::_Runtime::_hint("The production starts with $what. That means that the
                      production can never successfully match, so it was
                      optimized out of the final parser$caveat. $advice");
        return 0;
    }
    return 1;
}

sub changesskip($)
{
    my $item;
    foreach $item (@{$_[0]->{"items"}})
    {
        if (ref($item) =~ /TestParser::_Runtime::(Action|Directive)/)
        {
            return 1 if $item->{code} =~ /\$skip\s*=/;
        }
    }
    return 0;
}

sub adddirective
{
    my ( $self, $whichop, $line, $name ) = @_;
    push @{$self->{op}},
        { type=>$whichop, line=>$line, name=>$name,
          offset=> scalar(@{$self->{items}}) };
}

sub addscore
{
    my ( $self, $code, $lookahead, $line ) = @_;
    $self->additem(TestParser::_Runtime::Directive->new(
                  "local \$^W;
                   my \$thisscore = do { $code } + 0;
                   if (!defined(\$score) || \$thisscore>\$score)
                    { \$score=\$thisscore; \$score_return=\$item[-1]; }
                   undef;", $lookahead, $line,"<score: $code>") )
        unless $self->{items}[-1]->describe =~ /<score/;
    return 1;
}

sub check_pending
{
    my ( $self, $line ) = @_;
    if ($self->{op})
    {
        while (my $next = pop @{$self->{op}})
        {
        TestParser::_Runtime::_error("Incomplete <$next->{type}op:...>.", $line);
        TestParser::_Runtime::_hint(
            "The current production ended without completing the
             <$next->{type}op:...> directive that started near line
             $next->{line}. Did you forget the closing '>'?");
        }
    }
    return 1;
}

sub enddirective
{
    my ( $self, $line, $minrep, $maxrep ) = @_;
    unless ($self->{op})
    {
        TestParser::_Runtime::_error("Unmatched > found.", $line);
        TestParser::_Runtime::_hint(
            "A '>' angle bracket was encountered, which typically
             indicates the end of a directive. However no suitable
             preceding directive was encountered. Typically this
             indicates either a extra '>' in the grammar, or a
             problem inside the previous directive.");
        return;
    }
    my $op = pop @{$self->{op}};
    my $span = @{$self->{items}} - $op->{offset};
    if ($op->{type} =~ /left|right/)
    {
        if ($span != 3)
        {
        TestParser::_Runtime::_error(
            "Incorrect <$op->{type}op:...> specification:
             expected 3 args, but found $span instead", $line);
        TestParser::_Runtime::_hint(
            "The <$op->{type}op:...> directive requires a
             sequence of exactly three elements. For example:
             <$op->{type}op:leftarg /op/ rightarg>");
        }
        else
        {
        push @{$self->{items}},
            TestParser::_Runtime::Operator->new(
                $op->{type}, $minrep, $maxrep, splice(@{$self->{"items"}}, -3));
        $self->{items}[-1]->sethashname($self);
        $self->{items}[-1]{name} = $op->{name};
        }
    }
}

sub prevwasreturn
{
    my ( $self, $line ) = @_;
    unless (@{$self->{items}})
    {
        TestParser::_Runtime::_error(
            "Incorrect <return:...> specification:
            expected item missing", $line);
        TestParser::_Runtime::_hint(
            "The <return:...> directive requires a
            sequence of at least one item. For example:
            <return: list>");
        return;
    }
    push @{$self->{items}},
        TestParser::_Runtime::Result->new();
}

sub additem
{
    my ( $self, $item ) = @_;
    $item->sethashname($self);
    push @{$self->{"items"}}, $item;
    return $item;
}

sub _duplicate_itempos
{
    my ($src) = @_;
    my $dst = {};

    foreach (keys %$src)
    {
        %{$dst->{$_}} = %{$src->{$_}};
    }
    $dst;
}

sub _update_itempos
{
    my ($dst, $src, $typekeys, $poskeys) = @_;

    my @typekeys = 'ARRAY' eq ref $typekeys ?
      @$typekeys :
      keys %$src;

    foreach my $k (keys %$src)
    {
        if ('ARRAY' eq ref $poskeys)
        {
            @{$dst->{$k}}{@$poskeys} = @{$src->{$k}}{@$poskeys};
        }
        else
        {
            %{$dst->{$k}} = %{$src->{$k}};
        }
    }
}

sub preitempos
{
    return q
    {
        push @itempos, {'offset' => {'from'=>$thisoffset, 'to'=>undef},
                        'line'   => {'from'=>$thisline,   'to'=>undef},
                        'column' => {'from'=>$thiscolumn, 'to'=>undef} };
    }
}

sub incitempos
{
    return q
    {
        $itempos[$#itempos]{'offset'}{'from'} += length($lastsep);
        $itempos[$#itempos]{'line'}{'from'}   = $thisline;
        $itempos[$#itempos]{'column'}{'from'} = $thiscolumn;
    }
}

sub unincitempos
{
    # the next incitempos will properly set these two fields, but
    # {'offset'}{'from'} needs to be decreased by length($lastsep)
    # $itempos[$#itempos]{'line'}{'from'}
    # $itempos[$#itempos]{'column'}{'from'}
    return q
    {
        $itempos[$#itempos]{'offset'}{'from'} -= length($lastsep) if defined $lastsep;
    }
}

sub postitempos
{
    return q
    {
        $itempos[$#itempos]{'offset'}{'to'} = $prevoffset;
        $itempos[$#itempos]{'line'}{'to'}   = $prevline;
        $itempos[$#itempos]{'column'}{'to'} = $prevcolumn;
    }
}

sub code($$$$)
{
    my ($self,$namespace,$rule,$parser) = @_;
    my $code =
'
    while (!$_matched'
    . (defined $self->{"uncommit"} ? '' : ' && !$commit')
    . ')
    {
        ' .
        ($self->changesskip()
            ? 'local $skip = defined($skip) ? $skip : $TestParser::_Runtime::skip;'
            : '') .'
        TestParser::_Runtime::_trace(q{Trying production: ['
                      . $self->describe . ']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{' . $rule ->{name}. '},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[' . $self->{"number"} . '];
        ' . (defined $self->{"error"} ? '' : '$text = $_[1];' ) . '
        my $_savetext;
        @item = (q{' . $rule->{"name"} . '});
        %item = (__RULE__ => q{' . $rule->{"name"} . '});
        my $repcount = 0;

';
    $code .=
'        my @itempos = ({});
'           if $parser->{_check}{itempos};

    my $item;
    my $i;

    for ($i = 0; $i < @{$self->{"items"}}; $i++)
    {
        $item = ${$self->{items}}[$i];

        $code .= preitempos() if $parser->{_check}{itempos};

        $code .= $item->code($namespace,$rule,$parser->{_check});

        $code .= postitempos() if $parser->{_check}{itempos};

    }

    if ($parser->{_AUTOACTION} && defined($item) && !$item->isa("TestParser::_Runtime::Action"))
    {
        $code .= $parser->{_AUTOACTION}->code($namespace,$rule);
        TestParser::_Runtime::_warn(1,"Autogenerating action in rule
                       \"$rule->{name}\":
                        $parser->{_AUTOACTION}{code}")
        and
        TestParser::_Runtime::_hint("The \$::RD_AUTOACTION was defined,
                      so any production not ending in an
                      explicit action has the specified
                      \"auto-action\" automatically
                      appended.");
    }
    elsif ($parser->{_AUTOTREE} && defined($item) && !$item->isa("TestParser::_Runtime::Action"))
    {
        if ($i==1 && $item->isterminal)
        {
            $code .= $parser->{_AUTOTREE}{TERMINAL}->code($namespace,$rule);
        }
        else
        {
            $code .= $parser->{_AUTOTREE}{NODE}->code($namespace,$rule);
        }
        TestParser::_Runtime::_warn(1,"Autogenerating tree-building action in rule
                       \"$rule->{name}\"")
        and
        TestParser::_Runtime::_hint("The directive <autotree> was specified,
                      so any production not ending
                      in an explicit action has
                      some parse-tree building code
                      automatically appended.");
    }

    $code .=
'
        TestParser::_Runtime::_trace(q{>>'.TestParser::_Runtime::_matchtracemessage($self).' production: ['
                      . $self->describe . ']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{' . $rule->{name} . '},
                      $tracelevel)
                        if defined $::RD_TRACE;

' . ( $parser->{_check}{itempos} ? '
        if ( defined($_itempos) )
        {
            TestParser::_Runtime::Production::_update_itempos($_itempos, $itempos[ 1], undef, [qw(from)]);
            TestParser::_Runtime::Production::_update_itempos($_itempos, $itempos[-1], undef, [qw(to)]);
        }
' : '' ) . '

        $_matched = 1;
        last;
    }

';
    return $code;
}

1;

package TestParser::_Runtime::Action;

sub describe { undef }

sub sethashname { $_[0]->{hashname} = '__ACTION' . ++$_[1]->{actcount} .'__'; }

sub new
{
    my $class = ref($_[0]) || $_[0];
    bless
    {
        "code"      => $_[1],
        "lookahead" => $_[2],
        "line"      => $_[3],
    }, $class;
}

sub issubrule { undef }
sub isterminal { 0 }

sub code($$$$)
{
    my ($self, $namespace, $rule) = @_;

'
        TestParser::_Runtime::_trace(q{Trying action},
                      TestParser::_Runtime::_tracefirst($text),
                      q{' . $rule->{name} . '},
                      $tracelevel)
                        if defined $::RD_TRACE;
        ' . ($self->{"lookahead"} ? '$_savetext = $text;' : '' ) .'

        $_tok = ($_noactions) ? 0 : do ' . $self->{"code"} . ';
        ' . ($self->{"lookahead"}<0?'if':'unless') . ' (defined $_tok)
        {
            TestParser::_Runtime::_trace(q{<<'.TestParser::_Runtime::_matchtracemessage($self,1).' action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>'.TestParser::_Runtime::_matchtracemessage($self).' action<< (return value: [}
                      . $_tok . q{])},
                      TestParser::_Runtime::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        ' . ($self->{line}>=0 ? '$item{'. $self->{hashname} .'}=$_tok;' : '' ) .'
        ' . ($self->{"lookahead"} ? '$text = $_savetext;' : '' ) .'
'
}


1;

package TestParser::_Runtime::Directive;

sub sethashname { $_[0]->{hashname} = '__DIRECTIVE' . ++$_[1]->{dircount} .  '__'; }

sub issubrule { undef }
sub isterminal { 0 }
sub describe { $_[1] ? '' : $_[0]->{name} }

sub new ($$$$$)
{
    my $class = ref($_[0]) || $_[0];
    bless
    {
        "code"      => $_[1],
        "lookahead" => $_[2],
        "line"      => $_[3],
        "name"      => $_[4],
    }, $class;
}

sub code($$$$)
{
    my ($self, $namespace, $rule) = @_;

'
        ' . ($self->{"lookahead"} ? '$_savetext = $text;' : '' ) .'

        TestParser::_Runtime::_trace(q{Trying directive: ['
                    . $self->describe . ']},
                    TestParser::_Runtime::_tracefirst($text),
                      q{' . $rule->{name} . '},
                      $tracelevel)
                        if defined $::RD_TRACE; ' .'
        $_tok = do { ' . $self->{"code"} . ' };
        if (defined($_tok))
        {
            TestParser::_Runtime::_trace(q{>>'.TestParser::_Runtime::_matchtracemessage($self).' directive<< (return value: [}
                        . $_tok . q{])},
                        TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            TestParser::_Runtime::_trace(q{<<'.TestParser::_Runtime::_matchtracemessage($self,1).' directive>>},
                        TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        ' . ($self->{"lookahead"} ? '$text = $_savetext and ' : '' ) .'
        last '
        . ($self->{"lookahead"}<0?'if':'unless') . ' defined $_tok;
        push @item, $item{'.$self->{hashname}.'}=$_tok;
        ' . ($self->{"lookahead"} ? '$text = $_savetext;' : '' ) .'
'
}

1;

package TestParser::_Runtime::UncondReject;

sub issubrule { undef }
sub isterminal { 0 }
sub describe { $_[1] ? '' : $_[0]->{name} }
sub sethashname { $_[0]->{hashname} = '__DIRECTIVE' . ++$_[1]->{dircount} .  '__'; }

sub new ($$$;$)
{
    my $class = ref($_[0]) || $_[0];
    bless
    {
        "lookahead" => $_[1],
        "line"      => $_[2],
        "name"      => $_[3],
    }, $class;
}

# MARK, YOU MAY WANT TO OPTIMIZE THIS.


sub code($$$$)
{
    my ($self, $namespace, $rule) = @_;

'
        TestParser::_Runtime::_trace(q{>>Rejecting production<< (found '
                     . $self->describe . ')},
                     TestParser::_Runtime::_tracefirst($text),
                      q{' . $rule->{name} . '},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        ' . ($self->{"lookahead"} ? '$_savetext = $text;' : '' ) .'

        $_tok = undef;
        ' . ($self->{"lookahead"} ? '$text = $_savetext and ' : '' ) .'
        last '
        . ($self->{"lookahead"}<0?'if':'unless') . ' defined $_tok;
'
}

1;

package TestParser::_Runtime::Error;

sub issubrule { undef }
sub isterminal { 0 }
sub describe { $_[1] ? '' : $_[0]->{commitonly} ? '<error?:...>' : '<error...>' }
sub sethashname { $_[0]->{hashname} = '__DIRECTIVE' . ++$_[1]->{dircount} .  '__'; }

sub new ($$$$$)
{
    my $class = ref($_[0]) || $_[0];
    bless
    {
        "msg"        => $_[1],
        "lookahead"  => $_[2],
        "commitonly" => $_[3],
        "line"       => $_[4],
    }, $class;
}

sub code($$$$)
{
    my ($self, $namespace, $rule) = @_;

    my $action = '';

    if ($self->{"msg"})  # ERROR MESSAGE SUPPLIED
    {
        #WAS: $action .= "TestParser::_Runtime::_error(qq{$self->{msg}}" .  ',$thisline);';
        $action .= 'push @{$thisparser->{errors}}, [qq{'.$self->{msg}.'},$thisline];';

    }
    else      # GENERATE ERROR MESSAGE DURING PARSE
    {
        $action .= '
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: TestParser::_Runtime::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        ';
    }

    my $dir =
          new TestParser::_Runtime::Directive('if (' .
        ($self->{"commitonly"} ? '$commit' : '1') .
        ") { do {$action} unless ".' $_noactions; undef } else {0}',
                    $self->{"lookahead"},0,$self->describe);
    $dir->{hashname} = $self->{hashname};
    return $dir->code($namespace, $rule, 0);
}

1;

package TestParser::_Runtime::Token;

sub sethashname { $_[0]->{hashname} = '__PATTERN' . ++$_[1]->{patcount} . '__'; }

sub issubrule { undef }
sub isterminal { 1 }
sub describe ($) { shift->{'description'}}


# ARGS ARE: $self, $pattern, $left_delim, $modifiers, $lookahead, $linenum
sub new ($$$$$$)
{
    my $class = ref($_[0]) || $_[0];
    my $pattern = $_[1];
    my $pat = $_[1];
    my $ldel = $_[2];
    my $rdel = $ldel;
    $rdel =~ tr/{[(</}])>/;

    my $mod = $_[3];

    my $desc;

    if ($ldel eq '/') { $desc = "$ldel$pattern$rdel$mod" }
    else          { $desc = "m$ldel$pattern$rdel$mod" }
    $desc =~ s/\\/\\\\/g;
    $desc =~ s/\$$/\\\$/g;
    $desc =~ s/}/\\}/g;
    $desc =~ s/{/\\{/g;

    if (!eval "no strict;
           local \$SIG{__WARN__} = sub {0};
           '' =~ m$ldel$pattern$rdel$mod" and $@)
    {
        TestParser::_Runtime::_warn(3, "Token pattern \"m$ldel$pattern$rdel$mod\"
                         may not be a valid regular expression",
                       $_[5]);
        $@ =~ s/ at \(eval.*/./;
        TestParser::_Runtime::_hint($@);
    }

    # QUIETLY PREVENT (WELL-INTENTIONED) CALAMITY
    $mod =~ s/[gc]//g;
    $pattern =~ s/(\A|[^\\])\\G/$1/g;

    bless
    {
        "pattern"   => $pattern,
        "ldelim"      => $ldel,
        "rdelim"      => $rdel,
        "mod"         => $mod,
        "lookahead"   => $_[4],
        "line"        => $_[5],
        "description" => $desc,
    }, $class;
}


sub code($$$$$)
{
    my ($self, $namespace, $rule, $check) = @_;
    my $ldel = $self->{"ldelim"};
    my $rdel = $self->{"rdelim"};
    my $sdel = $ldel;
    my $mod  = $self->{"mod"};

    $sdel =~ s/[[{(<]/{}/;

my $code = '
        TestParser::_Runtime::_trace(q{Trying terminal: [' . $self->describe
                      . ']}, TestParser::_Runtime::_tracefirst($text),
                      q{' . $rule->{name} . '},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{' . ($rule->hasleftmost($self) ? ''
                : $self->describe ) . '})->at($text);
        ' . ($self->{"lookahead"} ? '$_savetext = $text;' : '' ) . '

        ' . ($self->{"lookahead"}<0?'if':'unless')
        . ' ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and '
        . ($check->{itempos}? 'do {'.TestParser::_Runtime::Production::incitempos().' 1} and ' : '')
        . '  $text =~ m' . $ldel . '\A(?:' . $self->{"pattern"} . ')' . $rdel . $mod . ')
        {
            '.($self->{"lookahead"} ? '$text = $_savetext;' : '$text = $lastsep . $text if defined $lastsep;') .
            ($check->{itempos} ? TestParser::_Runtime::Production::unincitempos() : '') . '
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn\'t match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{'.$self->{hashname}.'}=$current_match;
        ' . ($self->{"lookahead"} ? '$text = $_savetext;' : '' ) .'
';

    return $code;
}

1;

package TestParser::_Runtime::Literal;

sub sethashname { $_[0]->{hashname} = '__STRING' . ++$_[1]->{strcount} . '__'; }

sub issubrule { undef }
sub isterminal { 1 }
sub describe ($) { shift->{'description'} }

sub new ($$$$)
{
    my $class = ref($_[0]) || $_[0];

    my $pattern = $_[1];

    my $desc = $pattern;
    $desc=~s/\\/\\\\/g;
    $desc=~s/}/\\}/g;
    $desc=~s/{/\\{/g;

    bless
    {
        "pattern"     => $pattern,
        "lookahead"   => $_[2],
        "line"        => $_[3],
        "description" => "'$desc'",
    }, $class;
}


sub code($$$$)
{
    my ($self, $namespace, $rule, $check) = @_;

my $code = '
        TestParser::_Runtime::_trace(q{Trying terminal: [' . $self->describe
                      . ']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{' . $rule->{name} . '},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{' . ($rule->hasleftmost($self) ? ''
                : $self->describe ) . '})->at($text);
        ' . ($self->{"lookahead"} ? '$_savetext = $text;' : '' ) . '

        ' . ($self->{"lookahead"}<0?'if':'unless')
        . ' ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and '
        . ($check->{itempos}? 'do {'.TestParser::_Runtime::Production::incitempos().' 1} and ' : '')
        . '  $text =~ m/\A' . quotemeta($self->{"pattern"}) . '/)
        {
            '.($self->{"lookahead"} ? '$text = $_savetext;' : '$text = $lastsep . $text if defined $lastsep;').'
            '. ($check->{itempos} ? TestParser::_Runtime::Production::unincitempos() : '') . '
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn\'t match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{'.$self->{hashname}.'}=$current_match;
        ' . ($self->{"lookahead"} ? '$text = $_savetext;' : '' ) .'
';

    return $code;
}

1;

package TestParser::_Runtime::InterpLit;

sub sethashname { $_[0]->{hashname} = '__STRING' . ++$_[1]->{strcount} . '__'; }

sub issubrule { undef }
sub isterminal { 1 }
sub describe ($) { shift->{'description'} }

sub new ($$$$)
{
    my $class = ref($_[0]) || $_[0];

    my $pattern = $_[1];
    $pattern =~ s#/#\\/#g;

    my $desc = $pattern;
    $desc=~s/\\/\\\\/g;
    $desc=~s/}/\\}/g;
    $desc=~s/{/\\{/g;

    bless
    {
        "pattern"   => $pattern,
        "lookahead" => $_[2],
        "line"      => $_[3],
        "description" => "'$desc'",
    }, $class;
}

sub code($$$$)
{
    my ($self, $namespace, $rule, $check) = @_;

my $code = '
        TestParser::_Runtime::_trace(q{Trying terminal: [' . $self->describe
                      . ']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{' . $rule->{name} . '},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{' . ($rule->hasleftmost($self) ? ''
                : $self->describe ) . '})->at($text);
        ' . ($self->{"lookahead"} ? '$_savetext = $text;' : '' ) . '

        ' . ($self->{"lookahead"}<0?'if':'unless')
        . ' ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and '
        . ($check->{itempos}? 'do {'.TestParser::_Runtime::Production::incitempos().' 1} and ' : '')
        . '  do { $_tok = "' . $self->{"pattern"} . '"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            '.($self->{"lookahead"} ? '$text = $_savetext;' : '$text = $lastsep . $text if defined $lastsep;').'
            '. ($check->{itempos} ? TestParser::_Runtime::Production::unincitempos() : '') . '
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn\'t match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{'.$self->{hashname}.'}=$_tok;
        ' . ($self->{"lookahead"} ? '$text = $_savetext;' : '' ) .'
';

    return $code;
}

1;

package TestParser::_Runtime::Subrule;

sub issubrule ($) { return $_[0]->{"subrule"} }
sub isterminal { 0 }
sub sethashname {}

sub describe ($)
{
    my $desc = $_[0]->{"implicit"} || $_[0]->{"subrule"};
    $desc = "<matchrule:$desc>" if $_[0]->{"matchrule"};
    return $desc;
}

sub callsyntax($$)
{
    if ($_[0]->{"matchrule"})
    {
        return "&{'$_[1]'.qq{$_[0]->{subrule}}}";
    }
    else
    {
        return $_[1].$_[0]->{"subrule"};
    }
}

sub new ($$$$;$$$)
{
    my $class = ref($_[0]) || $_[0];
    bless
    {
        "subrule"   => $_[1],
        "lookahead" => $_[2],
        "line"      => $_[3],
        "implicit"  => $_[4] || undef,
        "matchrule" => $_[5],
        "argcode"   => $_[6] || undef,
    }, $class;
}


sub code($$$$)
{
    my ($self, $namespace, $rule, $check) = @_;

'
        TestParser::_Runtime::_trace(q{Trying subrule: [' . $self->{"subrule"} . ']},
                  TestParser::_Runtime::_tracefirst($text),
                  q{' . $rule->{"name"} . '},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(' . ($rule->hasleftmost($self) ? 'q{}'
                # WAS : 'qq{'.$self->describe.'}' ) . ')->at($text);
                : 'q{'.$self->describe.'}' ) . ')->at($text);
        ' . ($self->{"lookahead"} ? '$_savetext = $text;' : '' )
        . ($self->{"lookahead"}<0?'if':'unless')
        . ' (defined ($_tok = '
        . $self->callsyntax($namespace.'::')
        . '($thisparser,$text,$repeating,'
        . ($self->{"lookahead"}?'1':'$_noactions')
        . ($self->{argcode} ? ",sub { return $self->{argcode} }"
                   : ',sub { \\@arg }')
        . ($check->{"itempos"}?',$itempos[$#itempos]':',undef')
        . ')))
        {
            '.($self->{"lookahead"} ? '$text = $_savetext;' : '').'
            TestParser::_Runtime::_trace(q{<<'.TestParser::_Runtime::_matchtracemessage($self,1).' subrule: ['
            . $self->{subrule} . ']>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{' . $rule->{"name"} .'},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>'.TestParser::_Runtime::_matchtracemessage($self).' subrule: ['
                    . $self->{subrule} . ']<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{' . $rule->{"name"} .'},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{' . $self->{subrule} . '}} = $_tok;
        push @item, $_tok;
        ' . ($self->{"lookahead"} ? '$text = $_savetext;' : '' ) .'
        }
'
}

package TestParser::_Runtime::Repetition;

sub issubrule ($) { return $_[0]->{"subrule"} }
sub isterminal { 0 }
sub sethashname {  }

sub describe ($)
{
    my $desc = $_[0]->{"expected"} || $_[0]->{"subrule"};
    $desc = "<matchrule:$desc>" if $_[0]->{"matchrule"};
    return $desc;
}

sub callsyntax($$)
{
    if ($_[0]->{matchrule})
        { return "sub { goto &{''.qq{$_[1]$_[0]->{subrule}}} }"; }
    else
        { return "\\&$_[1]$_[0]->{subrule}"; }
}

sub new ($$$$$$$$$$)
{
    my ($self, $subrule, $repspec, $min, $max, $lookahead, $line, $parser, $matchrule, $argcode) = @_;
    my $class = ref($self) || $self;
    ($max, $min) = ( $min, $max) if ($max<$min);

    my $desc;
    if ($subrule=~/\A_alternation_\d+_of_production_\d+_of_rule/)
        { $desc = $parser->{"rules"}{$subrule}->expected }

    if ($lookahead)
    {
        if ($min>0)
        {
           return new TestParser::_Runtime::Subrule($subrule,$lookahead,$line,$desc,$matchrule,$argcode);
        }
        else
        {
            TestParser::_Runtime::_error("Not symbol (\"!\") before
                        \"$subrule\" doesn't make
                        sense.",$line);
            TestParser::_Runtime::_hint("Lookahead for negated optional
                       repetitions (such as
                       \"!$subrule($repspec)\" can never
                       succeed, since optional items always
                       match (zero times at worst).
                       Did you mean a single \"!$subrule\",
                       instead?");
        }
    }
    bless
    {
        "subrule"   => $subrule,
        "repspec"   => $repspec,
        "min"       => $min,
        "max"       => $max,
        "lookahead" => $lookahead,
        "line"      => $line,
        "expected"  => $desc,
        "argcode"   => $argcode || undef,
        "matchrule" => $matchrule,
    }, $class;
}

sub code($$$$)
{
    my ($self, $namespace, $rule, $check) = @_;

    my ($subrule, $repspec, $min, $max, $lookahead) =
        @{$self}{ qw{subrule repspec min max lookahead} };

'
        TestParser::_Runtime::_trace(q{Trying repeated subrule: [' . $self->describe . ']},
                  TestParser::_Runtime::_tracefirst($text),
                  q{' . $rule->{"name"} . '},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(' . ($rule->hasleftmost($self) ? 'q{}'
                # WAS : 'qq{'.$self->describe.'}' ) . ')->at($text);
                : 'q{'.$self->describe.'}' ) . ')->at($text);
        ' . ($self->{"lookahead"} ? '$_savetext = $text;' : '' ) .'
        unless (defined ($_tok = $thisparser->_parserepeat($text, '
        . $self->callsyntax($namespace.'::')
        . ', ' . $min . ', ' . $max . ', '
        . ($self->{"lookahead"}?'1':'$_noactions')
        . ',$expectation,'
        . ($self->{argcode} ? "sub { return $self->{argcode} }"
                        : 'sub { \\@arg }')
        . ($check->{"itempos"}?',$itempos[$#itempos]':',undef')
        . ')))
        {
            TestParser::_Runtime::_trace(q{<<'.TestParser::_Runtime::_matchtracemessage($self,1).' repeated subrule: ['
            . $self->describe . ']>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{' . $rule->{"name"} .'},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>'.TestParser::_Runtime::_matchtracemessage($self).' repeated subrule: ['
                    . $self->{subrule} . ']<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{' . $rule->{"name"} .'},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{' . "$self->{subrule}($self->{repspec})" . '}} = $_tok;
        push @item, $_tok;
        ' . ($self->{"lookahead"} ? '$text = $_savetext;' : '' ) .'

'
}

package TestParser::_Runtime::Result;

sub issubrule { 0 }
sub isterminal { 0 }
sub describe { '' }

sub new
{
    my ($class, $pos) = @_;

    bless {}, $class;
}

sub code($$$$)
{
    my ($self, $namespace, $rule) = @_;

    '
        $return = $item[-1];
    ';
}

package TestParser::_Runtime::Operator;

my @opertype = ( " non-optional", "n optional" );

sub issubrule { 0 }
sub isterminal { 0 }

sub describe { $_[0]->{"expected"} }
sub sethashname { $_[0]->{hashname} = '__DIRECTIVE' . ++$_[1]->{dircount} .  '__'; }


sub new
{
    my ($class, $type, $minrep, $maxrep, $leftarg, $op, $rightarg) = @_;

    bless
    {
        "type"      => "${type}op",
        "leftarg"   => $leftarg,
        "op"        => $op,
        "min"       => $minrep,
        "max"       => $maxrep,
        "rightarg"  => $rightarg,
        "expected"  => "<${type}op: ".$leftarg->describe." ".$op->describe." ".$rightarg->describe.">",
    }, $class;
}

sub code($$$$)
{
    my ($self, $namespace, $rule, $check) = @_;

    my @codeargs = @_[1..$#_];

    my ($leftarg, $op, $rightarg) =
        @{$self}{ qw{leftarg op rightarg} };

    my $code = '
        TestParser::_Runtime::_trace(q{Trying operator: [' . $self->describe . ']},
                  TestParser::_Runtime::_tracefirst($text),
                  q{' . $rule->{"name"} . '},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(' . ($rule->hasleftmost($self) ? 'q{}'
                # WAS : 'qq{'.$self->describe.'}' ) . ')->at($text);
                : 'q{'.$self->describe.'}' ) . ')->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;
';

    $code .= '
          my  $_itempos = $itempos[-1];
          my  $itemposfirst;
' if $check->{itempos};

    if ($self->{type} eq "leftop" )
    {
        $code .= '
          # MATCH LEFTARG
          ' . $leftarg->code(@codeargs) . '

';

        $code .= '
          if (defined($_itempos) and !defined($itemposfirst))
          {
              $itemposfirst = TestParser::_Runtime::Production::_duplicate_itempos($_itempos);
          }
' if $check->{itempos};

        $code .= '
          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < ' . $self->{max} . ')
          {
            $backtrack = 0;
            ' . $op->code(@codeargs) . '
            ' . ($op->isterminal() ? 'pop @item;' : '$backtrack=1;' ) . '
            ' . (ref($op) eq 'TestParser::_Runtime::Token'
                ? 'if (defined $1) {push @item, $item{'.($self->{name}||$self->{hashname}).'}=$1; $backtrack=1;}'
                : "" ) . '
            ' . $rightarg->code(@codeargs) . '
            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          ';
    }
    else
    {
        $code .= '
          my $savetext = $text;
          my $backtrack;
          # MATCH (LEFTARG OP)(s)
          while ($repcount < ' . $self->{max} . ')
          {
            $backtrack = 0;
            ' . $leftarg->code(@codeargs) . '
';
        $code .= '
            if (defined($_itempos) and !defined($itemposfirst))
            {
                $itemposfirst = TestParser::_Runtime::Production::_duplicate_itempos($_itempos);
            }
' if $check->{itempos};

        $code .= '
            $repcount++;
            $backtrack = 1;
            ' . $op->code(@codeargs) . '
            $savetext = $text;
            ' . ($op->isterminal() ? 'pop @item;' : "" ) . '
            ' . (ref($op) eq 'TestParser::_Runtime::Token' ? 'do { push @item, $item{'.($self->{name}||$self->{hashname}).'}=$1; } if defined $1;' : "" ) . '
          }
          $text = $savetext;
          pop @item if $backtrack;

          # MATCH RIGHTARG
          ' . $rightarg->code(@codeargs) . '
          $repcount++;
          ';
    }

    $code .= 'unless (@item) { undef $_tok; last }' unless $self->{min}==0;

    $code .= '
          $_tok = [ @item ];
';


    $code .= '
          if (defined $itemposfirst)
          {
              TestParser::_Runtime::Production::_update_itempos(
                  $_itempos, $itemposfirst, undef, [qw(from)]);
          }
' if $check->{itempos};

    $code .= '
          last;
        } # end of OPLOOP
';

    $code .= '
        unless ($repcount>='.$self->{min}.')
        {
            TestParser::_Runtime::_trace(q{<<'.TestParser::_Runtime::_matchtracemessage($self,1).' operator: ['
                          . $self->describe
                          . ']>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{' . $rule->{"name"} .'},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>'.TestParser::_Runtime::_matchtracemessage($self).' operator: ['
                      . $self->describe
                      . ']<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{' . $rule->{"name"} .'},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'.($self->{name}||$self->{hashname}).'}=$_tok||[];
';

    return $code;
}


package TestParser::_Runtime::Expectation;

sub new ($)
{
    bless {
        "failed"      => 0,
        "expected"    => "",
        "unexpected"      => "",
        "lastexpected"    => "",
        "lastunexpected"  => "",
        "defexpected"     => $_[1],
          };
}

sub is ($$)
{
    $_[0]->{lastexpected} = $_[1]; return $_[0];
}

sub at ($$)
{
    $_[0]->{lastunexpected} = $_[1]; return $_[0];
}

sub failed ($)
{
    return unless $_[0]->{lastexpected};
    $_[0]->{expected}   = $_[0]->{lastexpected}   unless $_[0]->{failed};
    $_[0]->{unexpected} = $_[0]->{lastunexpected} unless $_[0]->{failed};
    $_[0]->{failed} = 1;
}

sub message ($)
{
    my ($self) = @_;
    $self->{expected} = $self->{defexpected} unless $self->{expected};
    $self->{expected} =~ s/_/ /g;
    if (!$self->{unexpected} || $self->{unexpected} =~ /\A\s*\Z/s)
    {
        return "Was expecting $self->{expected}";
    }
    else
    {
        $self->{unexpected} =~ /\s*(.*)/;
        return "Was expecting $self->{expected} but found \"$1\" instead";
    }
}

1;

package TestParser::_Runtime;

use Carp;
use vars qw ( $AUTOLOAD $VERSION $_FILENAME);

my $ERRORS = 0;

our $VERSION = '1.967013';
$VERSION = eval $VERSION;
$_FILENAME=__FILE__;

# BUILDING A PARSER

my $nextnamespace = "namespace000001";

sub _nextnamespace()
{
    return "TestParser::_Runtime::" . $nextnamespace++;
}

# ARGS ARE: $class, $grammar, $compiling, $namespace
sub new ($$$$)
{
    my $class = ref($_[0]) || $_[0];
    local $TestParser::_Runtime::compiling = $_[2];
    my $name_space_name = defined $_[3]
        ? "TestParser::_Runtime::".$_[3]
        : _nextnamespace();
    my $self =
    {
        "rules"     => {},
        "namespace" => $name_space_name,
        "startcode" => '',
        "localvars" => '',
        "_AUTOACTION" => undef,
        "_AUTOTREE"   => undef,

        # Precompiled parsers used to set _precompiled, but that
        # wasn't present in some versions of TestParser::_Runtime used to
        # build precompiled parsers.  Instead, set a new
        # _not_precompiled flag, which is remove from future
        # Precompiled parsers at build time.
        "_not_precompiled" => 1,
    };


    if ($::RD_AUTOACTION) {
        my $sourcecode = $::RD_AUTOACTION;
        $sourcecode = "{ $sourcecode }"
            unless $sourcecode =~ /\A\s*\{.*\}\s*\Z/;
        $self->{_check}{itempos} =
            $sourcecode =~ /\@itempos\b|\$itempos\s*\[/;
        $self->{_AUTOACTION}
            = new TestParser::_Runtime::Action($sourcecode,0,-1)
    }

    bless $self, $class;
    return $self->Replace($_[1])
}

sub Compile($$$$) {
    die "Compilation of TestParser::_Runtime grammars not yet implemented\n";
}

sub DESTROY {
    my ($self) = @_;
    my $namespace = $self->{namespace};
    $namespace =~ s/TestParser::_Runtime:://;
    if ($self->{_not_precompiled}) {
        # BEGIN WORKAROUND
        # Perl has a bug that creates a circular reference between
        # @ISA and that variable's stash:
        #   https://rt.perl.org/rt3/Ticket/Display.html?id=92708
        # Emptying the array before deleting the stash seems to
        # prevent the leak.  Once the ticket above has been resolved,
        # these two lines can be removed.
        no strict 'refs';
        @{$self->{namespace} . '::ISA'} = ();
        # END WORKAROUND

        # Some grammars may contain circular references between rules,
        # such as:
        #   a: 'ID' | b
        #   b: '(' a ')'
        # Unless these references are broken, the subs stay around on
        # stash deletion below.  Iterate through the stash entries and
        # for each defined code reference, set it to reference sub {}
        # instead.
        {
            local $^W; # avoid 'sub redefined' warnings.
            my $blank_sub = sub {};
            while (my ($name, $glob) = each %{"TestParser::_Runtime::$namespace\::"}) {
                *$glob = $blank_sub if defined &$glob;
            }
        }

        # Delete the namespace's stash
        delete $TestParser::_Runtime::{$namespace.'::'};
    }
}

# BUILDING A GRAMMAR....

# ARGS ARE: $self, $grammar, $isimplicit, $isleftop
sub Replace ($$)
{
    # set $replace = 1 for _generate
    splice(@_, 2, 0, 1);

    return _generate(@_);
}

# ARGS ARE: $self, $grammar, $isimplicit, $isleftop
sub Extend ($$)
{
    # set $replace = 0 for _generate
    splice(@_, 2, 0, 0);

    return _generate(@_);
}

sub _no_rule ($$;$)
{
    _error("Ruleless $_[0] at start of grammar.",$_[1]);
    my $desc = $_[2] ? "\"$_[2]\"" : "";
    _hint("You need to define a rule for the $_[0] $desc
           to be part of.");
}

my $NEGLOOKAHEAD    =  '\G(\s*\.\.\.\!)';
my $POSLOOKAHEAD    =  '\G(\s*\.\.\.)';
my $RULE            =  '\G\s*(\w+)[ \t]*:';
my $PROD            =  '\G\s*([|])';
my $TOKEN           = q{\G\s*/((\\\\/|\\\\\\\\|[^/])*)/([cgimsox]*)};
my $MTOKEN          = q{\G\s*(m\s*[^\w\s])};
my $LITERAL         = q{\G\s*'((\\\\['\\\\]|[^'])*)'};
my $INTERPLIT       = q{\G\s*"((\\\\["\\\\]|[^"])*)"};
my $SUBRULE         =  '\G\s*(\w+)';
my $MATCHRULE       =  '\G(\s*<matchrule:)';
my $SIMPLEPAT       =  '((\\s+/[^/\\\\]*(?:\\\\.[^/\\\\]*)*/)?)';
my $OPTIONAL        =  '\G\((\?)'.$SIMPLEPAT.'\)';
my $ANY             =  '\G\((s\?)'.$SIMPLEPAT.'\)';
my $MANY            =  '\G\((s|\.\.)'.$SIMPLEPAT.'\)';
my $EXACTLY         =  '\G\(([1-9]\d*)'.$SIMPLEPAT.'\)';
my $BETWEEN         =  '\G\((\d+)\.\.([1-9]\d*)'.$SIMPLEPAT.'\)';
my $ATLEAST         =  '\G\((\d+)\.\.'.$SIMPLEPAT.'\)';
my $ATMOST          =  '\G\(\.\.([1-9]\d*)'.$SIMPLEPAT.'\)';
my $BADREP          =  '\G\((-?\d+)?\.\.(-?\d+)?'.$SIMPLEPAT.'\)';
my $ACTION          =  '\G\s*\{';
my $IMPLICITSUBRULE =  '\G\s*\(';
my $COMMENT         =  '\G\s*(#.*)';
my $COMMITMK        =  '\G\s*<commit>';
my $UNCOMMITMK      =  '\G\s*<uncommit>';
my $QUOTELIKEMK     =  '\G\s*<perl_quotelike>';
my $CODEBLOCKMK     =  '\G\s*<perl_codeblock(?:\s+([][()<>{}]+))?>';
my $VARIABLEMK      =  '\G\s*<perl_variable>';
my $NOCHECKMK       =  '\G\s*<nocheck>';
my $AUTOACTIONPATMK =  '\G\s*<autoaction:';
my $AUTOTREEMK      =  '\G\s*<autotree(?::\s*([\w:]+)\s*)?>';
my $AUTOSTUBMK      =  '\G\s*<autostub>';
my $AUTORULEMK      =  '\G\s*<autorule:(.*?)>';
my $REJECTMK        =  '\G\s*<reject>';
my $CONDREJECTMK    =  '\G\s*<reject:';
my $SCOREMK         =  '\G\s*<score:';
my $AUTOSCOREMK     =  '\G\s*<autoscore:';
my $SKIPMK          =  '\G\s*<skip:';
my $OPMK            =  '\G\s*<(left|right)op(?:=(\'.*?\'))?:';
my $ENDDIRECTIVEMK  =  '\G\s*>';
my $RESYNCMK        =  '\G\s*<resync>';
my $RESYNCPATMK     =  '\G\s*<resync:';
my $RULEVARPATMK    =  '\G\s*<rulevar:';
my $DEFERPATMK      =  '\G\s*<defer:';
my $TOKENPATMK      =  '\G\s*<token:';
my $AUTOERRORMK     =  '\G\s*<error(\??)>';
my $MSGERRORMK      =  '\G\s*<error(\??):';
my $NOCHECK         =  '\G\s*<nocheck>';
my $WARNMK          =  '\G\s*<warn((?::\s*(\d+)\s*)?)>';
my $HINTMK          =  '\G\s*<hint>';
my $TRACEBUILDMK    =  '\G\s*<trace_build((?::\s*(\d+)\s*)?)>';
my $TRACEPARSEMK    =  '\G\s*<trace_parse((?::\s*(\d+)\s*)?)>';
my $UNCOMMITPROD    = $PROD.'\s*<uncommit';
my $ERRORPROD       = $PROD.'\s*<error';
my $LONECOLON       =  '\G\s*:';
my $OTHER           =  '\G\s*([^\s]+)';

my @lines = 0;

sub _generate
{
    my ($self, $grammar, $replace, $isimplicit, $isleftop) = (@_, 0);

    my $aftererror = 0;
    my $lookahead = 0;
    my $lookaheadspec = "";
    my $must_pop_lines;
    if (! $lines[-1]) {
        push @lines, _linecount($grammar) ;
        $must_pop_lines = 1;
    }
    $self->{_check}{itempos} = ($grammar =~ /\@itempos\b|\$itempos\s*\[/)
        unless $self->{_check}{itempos};
    for (qw(thisoffset thiscolumn prevline prevoffset prevcolumn))
    {
        $self->{_check}{$_} =
            ($grammar =~ /\$$_/) || $self->{_check}{itempos}
                unless $self->{_check}{$_};
    }
    my $line;

    my $rule = undef;
    my $prod = undef;
    my $item = undef;
    my $lastgreedy = '';
    pos $grammar = 0;
    study $grammar;

    local $::RD_HINT  = $::RD_HINT;
    local $::RD_WARN  = $::RD_WARN;
    local $::RD_TRACE = $::RD_TRACE;
    local $::RD_CHECK = $::RD_CHECK;

    while (pos $grammar < length $grammar)
    {
        $line = $lines[-1] - _linecount($grammar) + 1;
        my $commitonly;
        my $code = "";
        my @components = ();
        if ($grammar =~ m/$COMMENT/gco)
        {
            _parse("a comment",0,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
            next;
        }
        elsif ($grammar =~ m/$NEGLOOKAHEAD/gco)
        {
            _parse("a negative lookahead",$aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
            $lookahead = $lookahead ? -$lookahead : -1;
            $lookaheadspec .= $1;
            next;   # SKIP LOOKAHEAD RESET AT END OF while LOOP
        }
        elsif ($grammar =~ m/$POSLOOKAHEAD/gco)
        {
            _parse("a positive lookahead",$aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
            $lookahead = $lookahead ? $lookahead : 1;
            $lookaheadspec .= $1;
            next;   # SKIP LOOKAHEAD RESET AT END OF while LOOP
        }
        elsif ($grammar =~ m/(?=$ACTION)/gco
            and do { ($code) = extract_codeblock($grammar); $code })
        {
            _parse("an action", $aftererror, $line, $code);
            $item = new TestParser::_Runtime::Action($code,$lookahead,$line);
            $prod and $prod->additem($item)
                  or  $self->_addstartcode($code);
        }
        elsif ($grammar =~ m/(?=$IMPLICITSUBRULE)/gco
            and do { ($code) = extract_codeblock($grammar,'{([',undef,'(',1);
                $code })
        {
            $code =~ s/\A\s*\(|\)\Z//g;
            _parse("an implicit subrule", $aftererror, $line,
                "( $code )");
            my $implicit = $rule->nextimplicit;
            return undef
                if !$self->_generate("$implicit : $code",$replace,1);
            my $pos = pos $grammar;
            substr($grammar,$pos,0,$implicit);
            pos $grammar = $pos;;
        }
        elsif ($grammar =~ m/$ENDDIRECTIVEMK/gco)
        {

        # EXTRACT TRAILING REPETITION SPECIFIER (IF ANY)

            my ($minrep,$maxrep) = (1,$MAXREP);
            if ($grammar =~ m/\G[(]/gc)
            {
                pos($grammar)--;

                if ($grammar =~ m/$OPTIONAL/gco)
                    { ($minrep, $maxrep) = (0,1) }
                elsif ($grammar =~ m/$ANY/gco)
                    { $minrep = 0 }
                elsif ($grammar =~ m/$EXACTLY/gco)
                    { ($minrep, $maxrep) = ($1,$1) }
                elsif ($grammar =~ m/$BETWEEN/gco)
                    { ($minrep, $maxrep) = ($1,$2) }
                elsif ($grammar =~ m/$ATLEAST/gco)
                    { $minrep = $1 }
                elsif ($grammar =~ m/$ATMOST/gco)
                    { $maxrep = $1 }
                elsif ($grammar =~ m/$MANY/gco)
                    { }
                elsif ($grammar =~ m/$BADREP/gco)
                {
                    _parse("an invalid repetition specifier", 0,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                    _error("Incorrect specification of a repeated directive",
                           $line);
                    _hint("Repeated directives cannot have
                           a maximum repetition of zero, nor can they have
                           negative components in their ranges.");
                }
            }

            $prod && $prod->enddirective($line,$minrep,$maxrep);
        }
        elsif ($grammar =~ m/\G\s*<[^m]/gc)
        {
            pos($grammar)-=2;

            if ($grammar =~ m/$OPMK/gco)
            {
                # $DB::single=1;
                _parse("a $1-associative operator directive", $aftererror, $line, "<$1op:...>");
                $prod->adddirective($1, $line,$2||'');
            }
            elsif ($grammar =~ m/$UNCOMMITMK/gco)
            {
                _parse("an uncommit marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                $item = new TestParser::_Runtime::Directive('$commit=0;1',
                                  $lookahead,$line,"<uncommit>");
                $prod and $prod->additem($item)
                      or  _no_rule("<uncommit>",$line);
            }
            elsif ($grammar =~ m/$QUOTELIKEMK/gco)
            {
                _parse("an perl quotelike marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                $item = new TestParser::_Runtime::Directive(
                    'my ($match,@res);
                     ($match,$text,undef,@res) =
                          Text::Balanced::extract_quotelike($text,$skip);
                      $match ? \@res : undef;
                    ', $lookahead,$line,"<perl_quotelike>");
                $prod and $prod->additem($item)
                      or  _no_rule("<perl_quotelike>",$line);
            }
            elsif ($grammar =~ m/$CODEBLOCKMK/gco)
            {
                my $outer = $1||"{}";
                _parse("an perl codeblock marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                $item = new TestParser::_Runtime::Directive(
                    'Text::Balanced::extract_codeblock($text,undef,$skip,\''.$outer.'\');
                    ', $lookahead,$line,"<perl_codeblock>");
                $prod and $prod->additem($item)
                      or  _no_rule("<perl_codeblock>",$line);
            }
            elsif ($grammar =~ m/$VARIABLEMK/gco)
            {
                _parse("an perl variable marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                $item = new TestParser::_Runtime::Directive(
                    'Text::Balanced::extract_variable($text,$skip);
                    ', $lookahead,$line,"<perl_variable>");
                $prod and $prod->additem($item)
                      or  _no_rule("<perl_variable>",$line);
            }
            elsif ($grammar =~ m/$NOCHECKMK/gco)
            {
                _parse("a disable checking marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                if ($rule)
                {
                    _error("<nocheck> directive not at start of grammar", $line);
                    _hint("The <nocheck> directive can only
                           be specified at the start of a
                           grammar (before the first rule
                           is defined.");
                }
                else
                {
                    local $::RD_CHECK = 1;
                }
            }
            elsif ($grammar =~ m/$AUTOSTUBMK/gco)
            {
                _parse("an autostub marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                $::RD_AUTOSTUB = "";
            }
            elsif ($grammar =~ m/$AUTORULEMK/gco)
            {
                _parse("an autorule marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                $::RD_AUTOSTUB = $1;
            }
            elsif ($grammar =~ m/$AUTOTREEMK/gco)
            {
                my $base = defined($1) ? $1 : "";
                my $current_match = substr($grammar, $-[0], $+[0] - $-[0]);
                $base .= "::" if $base && $base !~ /::$/;
                _parse("an autotree marker", $aftererror,$line, $current_match);
                if ($rule)
                {
                    _error("<autotree> directive not at start of grammar", $line);
                    _hint("The <autotree> directive can only
                           be specified at the start of a
                           grammar (before the first rule
                           is defined.");
                }
                else
                {
                    undef $self->{_AUTOACTION};
                    $self->{_AUTOTREE}{NODE}
                        = new TestParser::_Runtime::Action(q({bless \%item, ').$base.q('.$item[0]}),0,-1);
                    $self->{_AUTOTREE}{TERMINAL}
                        = new TestParser::_Runtime::Action(q({bless {__VALUE__=>$item[1]}, ').$base.q('.$item[0]}),0,-1);
                }
            }

            elsif ($grammar =~ m/$REJECTMK/gco)
            {
                _parse("an reject marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                $item = new TestParser::_Runtime::UncondReject($lookahead,$line,"<reject>");
                $prod and $prod->additem($item)
                      or  _no_rule("<reject>",$line);
            }
            elsif ($grammar =~ m/(?=$CONDREJECTMK)/gco
                and do { ($code) = extract_codeblock($grammar,'{',undef,'<');
                      $code })
            {
                _parse("a (conditional) reject marker", $aftererror,$line, $code );
                $code =~ /\A\s*<reject:(.*)>\Z/s;
                my $cond = $1;
                $item = new TestParser::_Runtime::Directive(
                          "($1) ? undef : 1", $lookahead,$line,"<reject:$cond>");
                $prod and $prod->additem($item)
                      or  _no_rule("<reject:$cond>",$line);
            }
            elsif ($grammar =~ m/(?=$SCOREMK)/gco
                and do { ($code) = extract_codeblock($grammar,'{',undef,'<');
                      $code })
            {
                _parse("a score marker", $aftererror,$line, $code );
                $code =~ /\A\s*<score:(.*)>\Z/s;
                $prod and $prod->addscore($1, $lookahead, $line)
                      or  _no_rule($code,$line);
            }
            elsif ($grammar =~ m/(?=$AUTOSCOREMK)/gco
                and do { ($code) = extract_codeblock($grammar,'{',undef,'<');
                     $code;
                       } )
            {
                _parse("an autoscore specifier", $aftererror,$line,$code);
                $code =~ /\A\s*<autoscore:(.*)>\Z/s;

                $rule and $rule->addautoscore($1,$self)
                      or  _no_rule($code,$line);

                $item = new TestParser::_Runtime::UncondReject($lookahead,$line,$code);
                $prod and $prod->additem($item)
                      or  _no_rule($code,$line);
            }
            elsif ($grammar =~ m/$RESYNCMK/gco)
            {
                _parse("a resync to newline marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                $item = new TestParser::_Runtime::Directive(
                          'if ($text =~ s/(\A[^\n]*\n)//) { $return = 0; $1; } else { undef }',
                          $lookahead,$line,"<resync>");
                $prod and $prod->additem($item)
                      or  _no_rule("<resync>",$line);
            }
            elsif ($grammar =~ m/(?=$RESYNCPATMK)/gco
                and do { ($code) = extract_bracketed($grammar,'<');
                      $code })
            {
                _parse("a resync with pattern marker", $aftererror,$line, $code );
                $code =~ /\A\s*<resync:(.*)>\Z/s;
                $item = new TestParser::_Runtime::Directive(
                          'if ($text =~ s/(\A'.$1.')//) { $return = 0; $1; } else { undef }',
                          $lookahead,$line,$code);
                $prod and $prod->additem($item)
                      or  _no_rule($code,$line);
            }
            elsif ($grammar =~ m/(?=$SKIPMK)/gco
                and do { ($code) = extract_codeblock($grammar,'<');
                      $code })
            {
                _parse("a skip marker", $aftererror,$line, $code );
                $code =~ /\A\s*<skip:(.*)>\Z/s;
                if ($rule) {
                    $item = new TestParser::_Runtime::Directive(
                        'my $oldskip = $skip; $skip='.$1.'; $oldskip',
                        $lookahead,$line,$code);
                    $prod and $prod->additem($item)
                      or  _no_rule($code,$line);
                } else {
                    #global <skip> directive
                    $self->{skip} = $1;
                }
            }
            elsif ($grammar =~ m/(?=$RULEVARPATMK)/gco
                and do { ($code) = extract_codeblock($grammar,'{',undef,'<');
                     $code;
                       } )
            {
                _parse("a rule variable specifier", $aftererror,$line,$code);
                $code =~ /\A\s*<rulevar:(.*)>\Z/s;

                $rule and $rule->addvar($1,$self)
                      or  _no_rule($code,$line);

                $item = new TestParser::_Runtime::UncondReject($lookahead,$line,$code);
                $prod and $prod->additem($item)
                      or  _no_rule($code,$line);
            }
            elsif ($grammar =~ m/(?=$AUTOACTIONPATMK)/gco
                and do { ($code) = extract_codeblock($grammar,'{',undef,'<');
                     $code;
                       } )
            {
                _parse("an autoaction specifier", $aftererror,$line,$code);
                $code =~ s/\A\s*<autoaction:(.*)>\Z/$1/s;
                if ($code =~ /\A\s*[^{]|[^}]\s*\Z/) {
                    $code = "{ $code }"
                }
        $self->{_check}{itempos} =
            $code =~ /\@itempos\b|\$itempos\s*\[/;
        $self->{_AUTOACTION}
            = new TestParser::_Runtime::Action($code,0,-$line)
            }
            elsif ($grammar =~ m/(?=$DEFERPATMK)/gco
                and do { ($code) = extract_codeblock($grammar,'{',undef,'<');
                     $code;
                       } )
            {
                _parse("a deferred action specifier", $aftererror,$line,$code);
                $code =~ s/\A\s*<defer:(.*)>\Z/$1/s;
                if ($code =~ /\A\s*[^{]|[^}]\s*\Z/)
                {
                    $code = "{ $code }"
                }

                $item = new TestParser::_Runtime::Directive(
                          "push \@{\$thisparser->{deferred}}, sub $code;",
                          $lookahead,$line,"<defer:$code>");
                $prod and $prod->additem($item)
                      or  _no_rule("<defer:$code>",$line);

                $self->{deferrable} = 1;
            }
            elsif ($grammar =~ m/(?=$TOKENPATMK)/gco
                and do { ($code) = extract_codeblock($grammar,'{',undef,'<');
                     $code;
                       } )
            {
                _parse("a token constructor", $aftererror,$line,$code);
                $code =~ s/\A\s*<token:(.*)>\Z/$1/s;

                my $types = eval 'no strict; local $SIG{__WARN__} = sub {0}; my @arr=('.$code.'); @arr' || ();
                if (!$types)
                {
                    _error("Incorrect token specification: \"$@\"", $line);
                    _hint("The <token:...> directive requires a list
                           of one or more strings representing possible
                           types of the specified token. For example:
                           <token:NOUN,VERB>");
                }
                else
                {
                    $item = new TestParser::_Runtime::Directive(
                              'no strict;
                               $return = { text => $item[-1] };
                               @{$return->{type}}{'.$code.'} = (1..'.$types.');',
                              $lookahead,$line,"<token:$code>");
                    $prod and $prod->additem($item)
                          or  _no_rule("<token:$code>",$line);
                }
            }
            elsif ($grammar =~ m/$COMMITMK/gco)
            {
                _parse("an commit marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                $item = new TestParser::_Runtime::Directive('$commit = 1',
                                  $lookahead,$line,"<commit>");
                $prod and $prod->additem($item)
                      or  _no_rule("<commit>",$line);
            }
            elsif ($grammar =~ m/$NOCHECKMK/gco) {
                _parse("an hint request", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
        $::RD_CHECK = 0;
        }
            elsif ($grammar =~ m/$HINTMK/gco) {
                _parse("an hint request", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
        $::RD_HINT = $self->{__HINT__} = 1;
        }
            elsif ($grammar =~ m/$WARNMK/gco) {
                _parse("an warning request", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
        $::RD_WARN = $self->{__WARN__} = $1 ? $2+0 : 1;
        }
            elsif ($grammar =~ m/$TRACEBUILDMK/gco) {
                _parse("an grammar build trace request", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
        $::RD_TRACE = $1 ? $2+0 : 1;
        }
            elsif ($grammar =~ m/$TRACEPARSEMK/gco) {
                _parse("an parse trace request", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
        $self->{__TRACE__} = $1 ? $2+0 : 1;
        }
            elsif ($grammar =~ m/$AUTOERRORMK/gco)
            {
                $commitonly = $1;
                _parse("an error marker", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
                $item = new TestParser::_Runtime::Error('',$lookahead,$1,$line);
                $prod and $prod->additem($item)
                      or  _no_rule("<error>",$line);
                $aftererror = !$commitonly;
            }
            elsif ($grammar =~ m/(?=$MSGERRORMK)/gco
                and do { $commitonly = $1;
                     ($code) = extract_bracketed($grammar,'<');
                    $code })
            {
                _parse("an error marker", $aftererror,$line,$code);
                $code =~ /\A\s*<error\??:(.*)>\Z/s;
                $item = new TestParser::_Runtime::Error($1,$lookahead,$commitonly,$line);
                $prod and $prod->additem($item)
                      or  _no_rule("$code",$line);
                $aftererror = !$commitonly;
            }
            elsif (do { $commitonly = $1;
                     ($code) = extract_bracketed($grammar,'<');
                    $code })
            {
                if ($code =~ /^<[A-Z_]+>$/)
                {
                    _error("Token items are not yet
                    supported: \"$code\"",
                           $line);
                    _hint("Items like $code that consist of angle
                    brackets enclosing a sequence of
                    uppercase characters will eventually
                    be used to specify pre-lexed tokens
                    in a grammar. That functionality is not
                    yet implemented. Or did you misspell
                    \"$code\"?");
                }
                else
                {
                    _error("Untranslatable item encountered: \"$code\"",
                           $line);
                    _hint("Did you misspell \"$code\"
                           or forget to comment it out?");
                }
            }
        }
        elsif ($grammar =~ m/$RULE/gco)
        {
            _parseunneg("a rule declaration", 0,
                    $lookahead,$line, substr($grammar, $-[0], $+[0] - $-[0]) ) or next;
            my $rulename = $1;
            if ($rulename =~ /Replace|Extend|Precompile|PrecompiledRuntime|Save/ )
            {
                _warn(2,"Rule \"$rulename\" hidden by method
                       TestParser::_Runtime::$rulename",$line)
                and
                _hint("The rule named \"$rulename\" cannot be directly
                       called through the TestParser::_Runtime object
                       for this grammar (although it may still
                       be used as a subrule of other rules).
                       It can't be directly called because
                       TestParser::_Runtime::$rulename is already defined (it
                       is the standard method of all
                       parsers).");
            }
            $rule = new TestParser::_Runtime::Rule($rulename,$self,$line,$replace);
            $prod->check_pending($line) if $prod;
            $prod = $rule->addprod( new TestParser::_Runtime::Production );
            $aftererror = 0;
        }
        elsif ($grammar =~ m/$UNCOMMITPROD/gco)
        {
            pos($grammar)-=9;
            _parseunneg("a new (uncommitted) production",
                    0, $lookahead, $line, substr($grammar, $-[0], $+[0] - $-[0]) ) or next;

            $prod->check_pending($line) if $prod;
            $prod = new TestParser::_Runtime::Production($line,1);
            $rule and $rule->addprod($prod)
                  or  _no_rule("<uncommit>",$line);
            $aftererror = 0;
        }
        elsif ($grammar =~ m/$ERRORPROD/gco)
        {
            pos($grammar)-=6;
            _parseunneg("a new (error) production", $aftererror,
                    $lookahead,$line, substr($grammar, $-[0], $+[0] - $-[0]) ) or next;
            $prod->check_pending($line) if $prod;
            $prod = new TestParser::_Runtime::Production($line,0,1);
            $rule and $rule->addprod($prod)
                  or  _no_rule("<error>",$line);
            $aftererror = 0;
        }
        elsif ($grammar =~ m/$PROD/gco)
        {
            _parseunneg("a new production", 0,
                    $lookahead,$line, substr($grammar, $-[0], $+[0] - $-[0]) ) or next;
            $rule
              and (!$prod || $prod->check_pending($line))
              and $prod = $rule->addprod(new TestParser::_Runtime::Production($line))
            or  _no_rule("production",$line);
            $aftererror = 0;
        }
        elsif ($grammar =~ m/$LITERAL/gco)
        {
            my $literal = $1;
            ($code = $literal) =~ s/\\\\/\\/g;
            _parse("a literal terminal", $aftererror,$line,$literal);
            $item = new TestParser::_Runtime::Literal($code,$lookahead,$line);
            $prod and $prod->additem($item)
                  or  _no_rule("literal terminal",$line,"'$literal'");
        }
        elsif ($grammar =~ m/$INTERPLIT/gco)
        {
            _parse("an interpolated literal terminal", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
            $item = new TestParser::_Runtime::InterpLit($1,$lookahead,$line);
            $prod and $prod->additem($item)
                  or  _no_rule("interpolated literal terminal",$line,"'$1'");
        }
        elsif ($grammar =~ m/$TOKEN/gco)
        {
            _parse("a /../ pattern terminal", $aftererror,$line, substr($grammar, $-[0], $+[0] - $-[0]) );
            $item = new TestParser::_Runtime::Token($1,'/',$3?$3:'',$lookahead,$line);
            $prod and $prod->additem($item)
                  or  _no_rule("pattern terminal",$line,"/$1/");
        }
        elsif ($grammar =~ m/(?=$MTOKEN)/gco
            and do { ($code, undef, @components)
                    = extract_quotelike($grammar);
                 $code }
              )

        {
            _parse("an m/../ pattern terminal", $aftererror,$line,$code);
            $item = new TestParser::_Runtime::Token(@components[3,2,8],
                                 $lookahead,$line);
            $prod and $prod->additem($item)
                  or  _no_rule("pattern terminal",$line,$code);
        }
        elsif ($grammar =~ m/(?=$MATCHRULE)/gco
                and do { ($code) = extract_bracketed($grammar,'<');
                     $code
                       }
               or $grammar =~ m/$SUBRULE/gco
                and $code = $1)
        {
            my $name = $code;
            my $matchrule = 0;
            if (substr($name,0,1) eq '<')
            {
                $name =~ s/$MATCHRULE\s*//;
                $name =~ s/\s*>\Z//;
                $matchrule = 1;
            }

        # EXTRACT TRAILING ARG LIST (IF ANY)

            my ($argcode) = extract_codeblock($grammar, "[]",'') || '';

        # EXTRACT TRAILING REPETITION SPECIFIER (IF ANY)

            if ($grammar =~ m/\G[(]/gc)
            {
                pos($grammar)--;

                if ($grammar =~ m/$OPTIONAL/gco)
                {
                    _parse("an zero-or-one subrule match", $aftererror,$line,"$code$argcode($1)");
                    $item = new TestParser::_Runtime::Repetition($name,$1,0,1,
                                       $lookahead,$line,
                                       $self,
                                       $matchrule,
                                       $argcode);
                    $prod and $prod->additem($item)
                          or  _no_rule("repetition",$line,"$code$argcode($1)");

                    !$matchrule and $rule and $rule->addcall($name);
                }
                elsif ($grammar =~ m/$ANY/gco)
                {
                    _parse("a zero-or-more subrule match", $aftererror,$line,"$code$argcode($1)");
                    if ($2)
                    {
                        my $pos = pos $grammar;
                        substr($grammar,$pos,0,
                               "<leftop='$name(s?)': $name $2 $name>(s?) ");

                        pos $grammar = $pos;
                    }
                    else
                    {
                        $item = new TestParser::_Runtime::Repetition($name,$1,0,$MAXREP,
                                           $lookahead,$line,
                                           $self,
                                           $matchrule,
                                           $argcode);
                        $prod and $prod->additem($item)
                              or  _no_rule("repetition",$line,"$code$argcode($1)");

                        !$matchrule and $rule and $rule->addcall($name);

                        _check_insatiable($name,$1,$grammar,$line) if $::RD_CHECK;
                    }
                }
                elsif ($grammar =~ m/$MANY/gco)
                {
                    _parse("a one-or-more subrule match", $aftererror,$line,"$code$argcode($1)");
                    if ($2)
                    {
                        # $DB::single=1;
                        my $pos = pos $grammar;
                        substr($grammar,$pos,0,
                               "<leftop='$name(s)': $name $2 $name> ");

                        pos $grammar = $pos;
                    }
                    else
                    {
                        $item = new TestParser::_Runtime::Repetition($name,$1,1,$MAXREP,
                                           $lookahead,$line,
                                           $self,
                                           $matchrule,
                                           $argcode);

                        $prod and $prod->additem($item)
                              or  _no_rule("repetition",$line,"$code$argcode($1)");

                        !$matchrule and $rule and $rule->addcall($name);

                        _check_insatiable($name,$1,$grammar,$line) if $::RD_CHECK;
                    }
                }
                elsif ($grammar =~ m/$EXACTLY/gco)
                {
                    _parse("an exactly-$1-times subrule match", $aftererror,$line,"$code$argcode($1)");
                    if ($2)
                    {
                        my $pos = pos $grammar;
                        substr($grammar,$pos,0,
                               "<leftop='$name($1)': $name $2 $name>($1) ");

                        pos $grammar = $pos;
                    }
                    else
                    {
                        $item = new TestParser::_Runtime::Repetition($name,$1,$1,$1,
                                           $lookahead,$line,
                                           $self,
                                           $matchrule,
                                           $argcode);
                        $prod and $prod->additem($item)
                              or  _no_rule("repetition",$line,"$code$argcode($1)");

                        !$matchrule and $rule and $rule->addcall($name);
                    }
                }
                elsif ($grammar =~ m/$BETWEEN/gco)
                {
                    _parse("a $1-to-$2 subrule match", $aftererror,$line,"$code$argcode($1..$2)");
                    if ($3)
                    {
                        my $pos = pos $grammar;
                        substr($grammar,$pos,0,
                               "<leftop='$name($1..$2)': $name $3 $name>($1..$2) ");

                        pos $grammar = $pos;
                    }
                    else
                    {
                        $item = new TestParser::_Runtime::Repetition($name,"$1..$2",$1,$2,
                                           $lookahead,$line,
                                           $self,
                                           $matchrule,
                                           $argcode);
                        $prod and $prod->additem($item)
                              or  _no_rule("repetition",$line,"$code$argcode($1..$2)");

                        !$matchrule and $rule and $rule->addcall($name);
                    }
                }
                elsif ($grammar =~ m/$ATLEAST/gco)
                {
                    _parse("a $1-or-more subrule match", $aftererror,$line,"$code$argcode($1..)");
                    if ($2)
                    {
                        my $pos = pos $grammar;
                        substr($grammar,$pos,0,
                               "<leftop='$name($1..)': $name $2 $name>($1..) ");

                        pos $grammar = $pos;
                    }
                    else
                    {
                        $item = new TestParser::_Runtime::Repetition($name,"$1..",$1,$MAXREP,
                                           $lookahead,$line,
                                           $self,
                                           $matchrule,
                                           $argcode);
                        $prod and $prod->additem($item)
                              or  _no_rule("repetition",$line,"$code$argcode($1..)");

                        !$matchrule and $rule and $rule->addcall($name);
                        _check_insatiable($name,"$1..",$grammar,$line) if $::RD_CHECK;
                    }
                }
                elsif ($grammar =~ m/$ATMOST/gco)
                {
                    _parse("a one-to-$1 subrule match", $aftererror,$line,"$code$argcode(..$1)");
                    if ($2)
                    {
                        my $pos = pos $grammar;
                        substr($grammar,$pos,0,
                               "<leftop='$name(..$1)': $name $2 $name>(..$1) ");

                        pos $grammar = $pos;
                    }
                    else
                    {
                        $item = new TestParser::_Runtime::Repetition($name,"..$1",1,$1,
                                           $lookahead,$line,
                                           $self,
                                           $matchrule,
                                           $argcode);
                        $prod and $prod->additem($item)
                              or  _no_rule("repetition",$line,"$code$argcode(..$1)");

                        !$matchrule and $rule and $rule->addcall($name);
                    }
                }
                elsif ($grammar =~ m/$BADREP/gco)
                {
                    my $current_match = substr($grammar, $-[0], $+[0] - $-[0]);
                    _parse("an subrule match with invalid repetition specifier", 0,$line, $current_match);
                    _error("Incorrect specification of a repeated subrule",
                           $line);
                    _hint("Repeated subrules like \"$code$argcode$current_match\" cannot have
                           a maximum repetition of zero, nor can they have
                           negative components in their ranges.");
                }
            }
            else
            {
                _parse("a subrule match", $aftererror,$line,$code);
                my $desc;
                if ($name=~/\A_alternation_\d+_of_production_\d+_of_rule/)
                    { $desc = $self->{"rules"}{$name}->expected }
                $item = new TestParser::_Runtime::Subrule($name,
                                       $lookahead,
                                       $line,
                                       $desc,
                                       $matchrule,
                                       $argcode);

                $prod and $prod->additem($item)
                      or  _no_rule("(sub)rule",$line,$name);

                !$matchrule and $rule and $rule->addcall($name);
            }
        }
        elsif ($grammar =~ m/$LONECOLON/gco   )
        {
            _error("Unexpected colon encountered", $line);
            _hint("Did you mean \"|\" (to start a new production)?
                   Or perhaps you forgot that the colon
                   in a rule definition must be
                   on the same line as the rule name?");
        }
        elsif ($grammar =~ m/$ACTION/gco   ) # BAD ACTION, ALREADY FAILED
        {
            _error("Malformed action encountered",
                   $line);
            _hint("Did you forget the closing curly bracket
                   or is there a syntax error in the action?");
        }
        elsif ($grammar =~ m/$OTHER/gco   )
        {
            _error("Untranslatable item encountered: \"$1\"",
                   $line);
            _hint("Did you misspell \"$1\"
                   or forget to comment it out?");
        }

        if ($lookaheadspec =~ tr /././ > 3)
        {
            $lookaheadspec =~ s/\A\s+//;
            $lookahead = $lookahead<0
                    ? 'a negative lookahead ("...!")'
                    : 'a positive lookahead ("...")' ;
            _warn(1,"Found two or more lookahead specifiers in a
                   row.",$line)
            and
            _hint("Multiple positive and/or negative lookaheads
                   are simply multiplied together to produce a
                   single positive or negative lookahead
                   specification. In this case the sequence
                   \"$lookaheadspec\" was reduced to $lookahead.
                   Was this your intention?");
        }
        $lookahead = 0;
        $lookaheadspec = "";

        $grammar =~ m/\G\s+/gc;
    }

    if ($must_pop_lines) {
        pop @lines;
    }

    unless ($ERRORS or $isimplicit or !$::RD_CHECK)
    {
        $self->_check_grammar();
    }

    unless ($ERRORS or $isimplicit or $TestParser::_Runtime::compiling)
    {
        my $code = $self->_code();
        if (defined $::RD_TRACE)
        {
            my $mode = ($nextnamespace eq "namespace000002") ? '>' : '>>';
            print STDERR "printing code (", length($code),") to RD_TRACE\n";
            local *TRACE_FILE;
            open TRACE_FILE, $mode, "RD_TRACE"
            and print TRACE_FILE "my \$ERRORS;\n$code"
            and close TRACE_FILE;
        }

        unless ( eval "$code 1" )
        {
            _error("Internal error in generated parser code!");
            $@ =~ s/at grammar/in grammar at/;
            _hint($@);
        }
    }

    if ($ERRORS and !_verbosity("HINT"))
    {
        local $::RD_HINT = defined $::RD_HINT ? $::RD_HINT : 1;
        _hint('Set $::RD_HINT (or -RD_HINT if you\'re using "perl -s")
               for hints on fixing these problems.  Use $::RD_HINT = 0
               to disable this message.');
    }
    if ($ERRORS) { $ERRORS=0; return }
    return $self;
}


sub _addstartcode($$)
{
    my ($self, $code) = @_;
    $code =~ s/\A\s*\{(.*)\}\Z/$1/s;

    $self->{"startcode"} .= "$code;\n";
}

# CHECK FOR GRAMMAR PROBLEMS....

sub _check_insatiable($$$$)
{
    my ($subrule,$repspec,$grammar,$line) = @_;
    pos($grammar)=pos($_[2]);
    return if $grammar =~ m/$OPTIONAL/gco || $grammar =~ m/$ANY/gco;
    my $min = 1;
    if ( $grammar =~ m/$MANY/gco
      || $grammar =~ m/$EXACTLY/gco
      || $grammar =~ m/$ATMOST/gco
      || $grammar =~ m/$BETWEEN/gco && do { $min=$2; 1 }
      || $grammar =~ m/$ATLEAST/gco && do { $min=$2; 1 }
      || $grammar =~ m/$SUBRULE(?!\s*:)/gco
       )
    {
        return unless $1 eq $subrule && $min > 0;
        my $current_match = substr($grammar, $-[0], $+[0] - $-[0]);
        _warn(3,"Subrule sequence \"$subrule($repspec) $current_match\" will
               (almost certainly) fail.",$line)
        and
        _hint("Unless subrule \"$subrule\" performs some cunning
               lookahead, the repetition \"$subrule($repspec)\" will
               insatiably consume as many matches of \"$subrule\" as it
               can, leaving none to match the \"$current_match\" that follows.");
    }
}

sub _check_grammar ($)
{
    my $self = shift;
    my $rules = $self->{"rules"};
    my $rule;
    foreach $rule ( values %$rules )
    {
        next if ! $rule->{"changed"};

    # CHECK FOR UNDEFINED RULES

        my $call;
        foreach $call ( @{$rule->{"calls"}} )
        {
            if (!defined ${$rules}{$call}
              &&!defined &{"TestParser::_Runtime::$call"})
            {
                if (!defined $::RD_AUTOSTUB)
                {
                    _warn(3,"Undefined (sub)rule \"$call\"
                          used in a production.")
                    and
                    _hint("Will you be providing this rule
                           later, or did you perhaps
                           misspell \"$call\"? Otherwise
                           it will be treated as an
                           immediate <reject>.");
                    eval "sub $self->{namespace}::$call {undef}";
                }
                else    # EXPERIMENTAL
                {
                    my $rule = qq{'$call'};
                    if ($::RD_AUTOSTUB and $::RD_AUTOSTUB ne "1") {
                        $rule = $::RD_AUTOSTUB;
                    }
                    _warn(1,"Autogenerating rule: $call")
                    and
                    _hint("A call was made to a subrule
                           named \"$call\", but no such
                           rule was specified. However,
                           since \$::RD_AUTOSTUB
                           was defined, a rule stub
                           ($call : $rule) was
                           automatically created.");

                    $self->_generate("$call: $rule",0,1);
                }
            }
        }

    # CHECK FOR LEFT RECURSION

        if ($rule->isleftrec($rules))
        {
            _error("Rule \"$rule->{name}\" is left-recursive.");
            _hint("Redesign the grammar so it's not left-recursive.
                   That will probably mean you need to re-implement
                   repetitions using the '(s)' notation.
                   For example: \"$rule->{name}(s)\".");
            next;
        }

    # CHECK FOR PRODUCTIONS FOLLOWING EMPTY PRODUCTIONS
      {
          my $hasempty;
          my $prod;
          foreach $prod ( @{$rule->{"prods"}} ) {
              if ($hasempty) {
                  _error("Production " . $prod->describe . " for \"$rule->{name}\"
                         will never be reached (preceding empty production will
                         always match first).");
                  _hint("Reorder the grammar so that the empty production
                         is last in the list or productions.");
                  last;
              }
              $hasempty ||= $prod->isempty();
          }
      }
    }
}

# GENERATE ACTUAL PARSER CODE

sub _code($)
{
    my $self = shift;
    my $initial_skip = defined($self->{skip}) ?
      '$skip = ' . $self->{skip} . ';' :
      $self->_dump([$skip],[qw(skip)]);

    my $code = qq!
package $self->{namespace};
use strict;
use vars qw(\$skip \$AUTOLOAD $self->{localvars} );
\@$self->{namespace}\::ISA = ();
$initial_skip
$self->{startcode}

{
local \$SIG{__WARN__} = sub {0};
# PRETEND TO BE IN TestParser::_Runtime NAMESPACE
*$self->{namespace}::AUTOLOAD   = sub
{
    no strict 'refs';
!
# This generated code uses ${"AUTOLOAD"} rather than $AUTOLOAD in
# order to avoid the circular reference documented here:
#    https://rt.perl.org/rt3/Public/Bug/Display.html?id=110248
# As a result of the investigation of
#    https://rt.cpan.org/Ticket/Display.html?id=53710
. qq!
    \${"AUTOLOAD"} =~ s/^$self->{namespace}/TestParser::_Runtime/;
    goto &{\${"AUTOLOAD"}};
}
}

!;
    $code .= "push \@$self->{namespace}\::ISA, 'TestParser::_Runtime';";
    $self->{"startcode"} = '';

    my $rule;
    # sort the rules to ensure the output is reproducible
    foreach $rule ( sort { $a->{name} cmp $b->{name} }
                    values %{$self->{"rules"}} )
    {
        if ($rule->{"changed"})
        {
            $code .= $rule->code($self->{"namespace"},$self);
            $rule->{"changed"} = 0;
        }
    }

    return $code;
}

# A wrapper for Data::Dumper->Dump, which localizes some variables to
# keep the output in a form suitable for TestParser::_Runtime.
#
# List of variables and their defaults taken from
# $Data::Dumper::VERSION == 2.158

sub _dump {
	require Data::Dumper;

	#
	# Allow the user's settings to persist for some features in case
	# RD_TRACE is set.  These shouldn't affect the eval()-ability of
	# the resulting parser.
	#

	#local $Data::Dumper::Indent = 2;
	#local $Data::Dumper::Useqq      = 0;
	#local $Data::Dumper::Quotekeys  = 1;
	#local $Data::Dumper::Useperl = 0;

	#
	# These may affect whether the output is valid perl code for
	# eval(), and must be controlled. Set them to their default
	# values.
	#

	local $Data::Dumper::Purity     = 0;
	local $Data::Dumper::Pad        = "";
	local $Data::Dumper::Varname    = "VAR";
	local $Data::Dumper::Terse      = 0;
	local $Data::Dumper::Freezer    = "";
	local $Data::Dumper::Toaster    = "";
	local $Data::Dumper::Deepcopy   = 0;
	local $Data::Dumper::Bless      = "bless";
	local $Data::Dumper::Maxdepth   = 0;
	local $Data::Dumper::Pair       = ' => ';
	local $Data::Dumper::Deparse    = 0;
	local $Data::Dumper::Sparseseen = 0;

	#
	# Modify the below options from their defaults.
	#

	# Sort the keys to ensure the output is reproducible
	local $Data::Dumper::Sortkeys   = 1;

	# Don't stop recursing
	local $Data::Dumper::Maxrecurse = 0;

	return Data::Dumper->Dump(@_[1..$#_]);
}

# EXECUTING A PARSE....

sub AUTOLOAD    # ($parser, $text; $linenum, @args)
{
    croak "Could not find method: $AUTOLOAD\n" unless ref $_[0];
    my $class = ref($_[0]) || $_[0];
    my $text = ref($_[1]) eq 'SCALAR' ? ${$_[1]} : "$_[1]";
    $_[0]->{lastlinenum} = _linecount($text);
    $_[0]->{lastlinenum} += ($_[2]||0) if @_ > 2;
    $_[0]->{offsetlinenum} = $_[0]->{lastlinenum};
    $_[0]->{fulltext} = $text;
    $_[0]->{fulltextlen} = length $text;
    $_[0]->{linecounter_cache} = {};
    $_[0]->{deferred} = [];
    $_[0]->{errors} = [];
    my @args = @_[3..$#_];
    my $args = sub { [ @args ] };

    $AUTOLOAD =~ s/$class/$_[0]->{namespace}/;
    no strict "refs";

    local $::RD_WARN  = $::RD_WARN  || $_[0]->{__WARN__};
    local $::RD_HINT  = $::RD_HINT  || $_[0]->{__HINT__};
    local $::RD_TRACE = $::RD_TRACE || $_[0]->{__TRACE__};

    croak "Unknown starting rule ($AUTOLOAD) called\n"
        unless defined &$AUTOLOAD;
    my $retval = &{$AUTOLOAD}(
        $_[0], # $parser
        $text, # $text
        undef, # $repeating
        undef, # $_noactions
        $args, # \@args
        undef, # $_itempos
    );


    if (defined $retval)
    {
        foreach ( @{$_[0]->{deferred}} ) { &$_; }
    }
    else
    {
        foreach ( @{$_[0]->{errors}} ) { _error(@$_); }
    }

    if (ref $_[1] eq 'SCALAR') { ${$_[1]} = $text }

    $ERRORS = 0;
    return $retval;
}

sub _parserepeat($$$$$$$$$)    # RETURNS A REF TO AN ARRAY OF MATCHES
{
    my ($parser, $text, $prod, $min, $max, $_noactions, $expectation, $argcode, $_itempos) = @_;
    my @tokens = ();

    my $itemposfirst;
    my $reps;
    for ($reps=0; $reps<$max;)
    {
        $expectation->at($text);
        my $_savetext = $text;
        my $prevtextlen = length $text;
        my $_tok;
        if (! defined ($_tok = &$prod($parser,$text,1,$_noactions,$argcode,$_itempos)))
        {
            $text = $_savetext;
            last;
        }

        if (defined($_itempos) and !defined($itemposfirst))
        {
            $itemposfirst = TestParser::_Runtime::Production::_duplicate_itempos($_itempos);
        }

        push @tokens, $_tok if defined $_tok;
        last if ++$reps >= $min and $prevtextlen == length $text;
    }

    do { $expectation->failed(); return undef} if $reps<$min;

    if (defined $itemposfirst)
    {
        TestParser::_Runtime::Production::_update_itempos($_itempos, $itemposfirst, undef, [qw(from)]);
    }

    $_[1] = $text;
    return [@tokens];
}

sub set_autoflush {
    my $orig_selected = select $_[0];
    $| = 1;
    select $orig_selected;
    return;
}

# ERROR REPORTING....

sub _write_ERROR {
    my ($errorprefix, $errortext) = @_;
    return if $errortext !~ /\S/;
    $errorprefix =~ s/\s+\Z//;
    local $^A = q{};

    formline(<<'END_FORMAT', $errorprefix, $errortext);
@>>>>>>>>>>>>>>>>>>>>: ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
END_FORMAT
    formline(<<'END_FORMAT', $errortext);
~~                     ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
END_FORMAT
    print {*STDERR} $^A;
}

# TRACING

my $TRACE_FORMAT = <<'END_FORMAT';
@>|@|||||||||@^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<|
  | ~~       |^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<|
END_FORMAT

my $TRACECONTEXT_FORMAT = <<'END_FORMAT';
@>|@|||||||||@                                      |^<<<<<<<<<<<<<<<<<<<<<<<<<<<
  | ~~       |                                      |^<<<<<<<<<<<<<<<<<<<<<<<<<<<
END_FORMAT

sub _write_TRACE {
    my ($tracelevel, $tracerulename, $tracemsg) = @_;
    return if $tracemsg !~ /\S/;
    $tracemsg =~ s/\s*\Z//;
    local $^A = q{};
    my $bar = '|';
    formline($TRACE_FORMAT, $tracelevel, $tracerulename, $bar, $tracemsg, $tracemsg);
    print {*STDERR} $^A;
}

sub _write_TRACECONTEXT {
    my ($tracelevel, $tracerulename, $tracecontext) = @_;
    return if $tracecontext !~ /\S/;
    $tracecontext =~ s/\s*\Z//;
    local $^A = q{};
    my $bar = '|';
    formline($TRACECONTEXT_FORMAT, $tracelevel, $tracerulename, $bar, $tracecontext, $tracecontext);
    print {*STDERR} $^A;
}

sub _verbosity($)
{
       defined $::RD_TRACE
    or defined $::RD_HINT    and  $::RD_HINT   and $_[0] =~ /ERRORS|WARN|HINT/
    or defined $::RD_WARN    and  $::RD_WARN   and $_[0] =~ /ERRORS|WARN/
    or defined $::RD_ERRORS  and  $::RD_ERRORS and $_[0] =~ /ERRORS/
}

sub _error($;$)
{
    $ERRORS++;
    return 0 if ! _verbosity("ERRORS");
    my $errortext   = $_[0];
    my $errorprefix = "ERROR" .  ($_[1] ? " (line $_[1])" : "");
    $errortext =~ s/\s+/ /g;
    print {*STDERR} "\n" if _verbosity("WARN");
    _write_ERROR($errorprefix, $errortext);
    return 1;
}

sub _warn($$;$)
{
    return 0 unless _verbosity("WARN") && ($::RD_HINT || $_[0] >= ($::RD_WARN||1));
    my $errortext   = $_[1];
    my $errorprefix = "Warning" .  ($_[2] ? " (line $_[2])" : "");
    print {*STDERR} "\n" if _verbosity("HINT");
    $errortext =~ s/\s+/ /g;
    _write_ERROR($errorprefix, $errortext);
    return 1;
}

sub _hint($)
{
    return 0 unless $::RD_HINT;
    my $errortext = $_[0];
    my $errorprefix = "Hint" .  ($_[1] ? " (line $_[1])" : "");
    $errortext =~ s/\s+/ /g;
    _write_ERROR($errorprefix, $errortext);
    return 1;
}

sub _tracemax($)
{
    if (defined $::RD_TRACE
        && $::RD_TRACE =~ /\d+/
        && $::RD_TRACE>1
        && $::RD_TRACE+10<length($_[0]))
    {
        my $count = length($_[0]) - $::RD_TRACE;
        return substr($_[0],0,$::RD_TRACE/2)
            . "...<$count>..."
            . substr($_[0],-$::RD_TRACE/2);
    }
    else
    {
        return substr($_[0],0,500);
    }
}

sub _tracefirst($)
{
    if (defined $::RD_TRACE
        && $::RD_TRACE =~ /\d+/
        && $::RD_TRACE>1
        && $::RD_TRACE+10<length($_[0]))
    {
        my $count = length($_[0]) - $::RD_TRACE;
        return substr($_[0],0,$::RD_TRACE) . "...<+$count>";
    }
    else
    {
        return substr($_[0],0,500);
    }
}

my $lastcontext = '';
my $lastrulename = '';
my $lastlevel = '';

sub _trace($;$$$)
{
    my $tracemsg      = $_[0];
    my $tracecontext  = $_[1]||$lastcontext;
    my $tracerulename = $_[2]||$lastrulename;
    my $tracelevel    = $_[3]||$lastlevel;
    if ($tracerulename) { $lastrulename = $tracerulename }
    if ($tracelevel)    { $lastlevel = $tracelevel }

    $tracecontext =~ s/\n/\\n/g;
    $tracecontext =~ s/\s+/ /g;
    $tracerulename = qq{$tracerulename};
    _write_TRACE($tracelevel, $tracerulename, $tracemsg);
    if ($tracecontext ne $lastcontext)
    {
        if ($tracecontext)
        {
            $lastcontext = _tracefirst($tracecontext);
            $tracecontext = qq{"$tracecontext"};
        }
        else
        {
            $tracecontext = qq{<NO TEXT LEFT>};
        }
        _write_TRACECONTEXT($tracelevel, $tracerulename, $tracecontext);
    }
}

sub _matchtracemessage
{
    my ($self, $reject) = @_;

    my $prefix = '';
    my $postfix = '';
    my $matched = not $reject;
    my @t = ("Matched", "Didn't match");
    if (exists $self->{lookahead} and $self->{lookahead})
    {
        $postfix = $reject ? "(reject)" : "(keep)";
        $prefix = "...";
        if ($self->{lookahead} < 0)
        {
            $prefix .= '!';
            $matched = not $matched;
        }
    }
    $prefix . ($matched ? $t[0] : $t[1]) . $postfix;
}

sub _parseunneg($$$$$)
{
    _parse($_[0],$_[1],$_[3],$_[4]);
    if ($_[2]<0)
    {
        _error("Can't negate \"$_[4]\".",$_[3]);
        _hint("You can't negate $_[0]. Remove the \"...!\" before
               \"$_[4]\".");
        return 0;
    }
    return 1;
}

sub _parse($$$$)
{
    my $what = $_[3];
       $what =~ s/^\s+//;
    if ($_[1])
    {
        _warn(3,"Found $_[0] ($what) after an unconditional <error>",$_[2])
        and
        _hint("An unconditional <error> always causes the
               production containing it to immediately fail.
               \u$_[0] that follows an <error>
               will never be reached.  Did you mean to use
               <error?> instead?");
    }

    return if ! _verbosity("TRACE");
    my $errortext = "Treating \"$what\" as $_[0]";
    my $errorprefix = "TestParser::_Runtime";
    $errortext =~ s/\s+/ /g;
    _write_ERROR($errorprefix, $errortext);
}

sub _linecount($) {
    scalar substr($_[0], pos $_[0]||0) =~ tr/\n//
}


package main;

use vars qw ( $RD_ERRORS $RD_WARN $RD_HINT $RD_TRACE $RD_CHECK );
$::RD_CHECK = 1;
$::RD_ERRORS = 1;
$::RD_WARN = 3;

1;

}
package TestParser;
{ my $ERRORS;


package TestParser::_Runtime::TestParser;
use strict;
use vars qw($skip $AUTOLOAD  );
@TestParser::_Runtime::TestParser::ISA = ();
$skip = '\\s*';



{
local $SIG{__WARN__} = sub {0};
# PRETEND TO BE IN TestParser::_Runtime NAMESPACE
*TestParser::_Runtime::TestParser::AUTOLOAD   = sub
{
    no strict 'refs';

    ${"AUTOLOAD"} =~ s/^TestParser::_Runtime::TestParser/TestParser::_Runtime/;
    goto &{${"AUTOLOAD"}};
}
}

push @TestParser::_Runtime::TestParser::ISA, 'TestParser::_Runtime';
# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::AND_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"AND_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [AND_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{AND_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: equality_expression /(&)/ equality_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: equality_expression /(&)/ equality_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{AND_expression});
        %item = (__RULE__ => q{AND_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: equality_expression /(&)/ equality_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{AND_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [equality_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{AND_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{equality_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::equality_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [equality_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{AND_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [equality_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{equality_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(&)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(&)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(&))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'equality_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [equality_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{AND_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{equality_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::equality_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [equality_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{AND_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [equality_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{equality_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: equality_expression /(&)/ equality_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{AND_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: equality_expression /(&)/ equality_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'equality_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: equality_expression /(&)/ equality_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{AND_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{AND_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{AND_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::ASSIGNMENT_OPERATOR
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ASSIGNMENT_OPERATOR"};

    TestParser::_Runtime::_trace(q{Trying rule: [ASSIGNMENT_OPERATOR]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{ASSIGNMENT_OPERATOR},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'=', or '*=', or '/=', or '%=', or '+=', or '-=', or '<<=', or '>>=', or '&=', or '^=', or '|='});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['*=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['*=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\*\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['*=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['/=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['/=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\/\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['/=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['%=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['%=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\%\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['%=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['+=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['+=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\+\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['+=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['-=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['-=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\-\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['-=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['<<=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[6];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['<<=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\<\<\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['<<=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['>>=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[7];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['>>=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\>\>\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['>>=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['&=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[8];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['&=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\&\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['&=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['^=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[9];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['^=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\^\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['^=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['|=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[10];
        $text = $_[1];
        my $_savetext;
        @item = (q{ASSIGNMENT_OPERATOR});
        %item = (__RULE__ => q{ASSIGNMENT_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['|=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\|\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['|=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{ASSIGNMENT_OPERATOR},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ASSIGNMENT_OPERATOR},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{ASSIGNMENT_OPERATOR},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::CHARACTER_CONSTANT
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"CHARACTER_CONSTANT"};

    TestParser::_Runtime::_trace(q{Trying rule: [CHARACTER_CONSTANT]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{CHARACTER_CONSTANT},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{/'([^\\\\'"]                          # None of these
         |\\\\['\\\\ntvbrfa'"]                  # or a backslash followed by one of those
         |\\\\[0-7]\{1,3\}|\\\\x\\d+)'             # or an octal or hex constant
        /x});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [/'([^\\\\'"]                          # None of these
         |\\\\['\\\\ntvbrfa'"]                  # or a backslash followed by one of those
         |\\\\[0-7]\{1,3\}|\\\\x\\d+)'             # or an octal or hex constant
        /x]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{CHARACTER_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{CHARACTER_CONSTANT});
        %item = (__RULE__ => q{CHARACTER_CONSTANT});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: [/'([^\\\\'"]                          # None of these
         |\\\\['\\\\ntvbrfa'"]                  # or a backslash followed by one of those
         |\\\\[0-7]\{1,3\}|\\\\x\\d+)'             # or an octal or hex constant
        /x]}, TestParser::_Runtime::_tracefirst($text),
                      q{CHARACTER_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:'([^\\'"]                          # None of these
         |\\['\\ntvbrfa'"]                  # or a backslash followed by one of those
         |\\[0-7]{1,3}|\\x\d+)'             # or an octal or hex constant
        )/x)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [/'([^\\\\'"]                          # None of these
         |\\\\['\\\\ntvbrfa'"]                  # or a backslash followed by one of those
         |\\\\[0-7]\{1,3\}|\\\\x\\d+)'             # or an octal or hex constant
        /x]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{CHARACTER_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{CHARACTER_CONSTANT},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{CHARACTER_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{CHARACTER_CONSTANT},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{CHARACTER_CONSTANT},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::ENUMERATION_CONSTANT
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ENUMERATION_CONSTANT"};

    TestParser::_Runtime::_trace(q{Trying rule: [ENUMERATION_CONSTANT]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{ENUMERATION_CONSTANT},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{INTEGER_CONSTANT});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [INTEGER_CONSTANT]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{ENUMERATION_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ENUMERATION_CONSTANT});
        %item = (__RULE__ => q{ENUMERATION_CONSTANT});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [INTEGER_CONSTANT]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{ENUMERATION_CONSTANT},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::INTEGER_CONSTANT($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [INTEGER_CONSTANT]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{ENUMERATION_CONSTANT},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [INTEGER_CONSTANT]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{ENUMERATION_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{INTEGER_CONSTANT}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [INTEGER_CONSTANT]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{ENUMERATION_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{ENUMERATION_CONSTANT},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{ENUMERATION_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ENUMERATION_CONSTANT},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{ENUMERATION_CONSTANT},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::FLOATING_CONSTANT
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"FLOATING_CONSTANT"};

    TestParser::_Runtime::_trace(q{Trying rule: [FLOATING_CONSTANT]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{FLOATING_CONSTANT},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{/(?:\\d+|(?=\\.\\d+))                  # No leading digits only if '.moreDigits' follows
         (?:\\.|(?=[eE]))                        # There may be no floating point only if an exponent is present
         \\d*                                    # Zero or more floating digits
         ([eE][+-]?\\d+)?                        # expontent
         [lLfF]?                                # Suffix
        /x});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [/(?:\\d+|(?=\\.\\d+))                  # No leading digits only if '.moreDigits' follows
         (?:\\.|(?=[eE]))                        # There may be no floating point only if an exponent is present
         \\d*                                    # Zero or more floating digits
         ([eE][+-]?\\d+)?                        # expontent
         [lLfF]?                                # Suffix
        /x]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{FLOATING_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{FLOATING_CONSTANT});
        %item = (__RULE__ => q{FLOATING_CONSTANT});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: [/(?:\\d+|(?=\\.\\d+))                  # No leading digits only if '.moreDigits' follows
         (?:\\.|(?=[eE]))                        # There may be no floating point only if an exponent is present
         \\d*                                    # Zero or more floating digits
         ([eE][+-]?\\d+)?                        # expontent
         [lLfF]?                                # Suffix
        /x]}, TestParser::_Runtime::_tracefirst($text),
                      q{FLOATING_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(?:\d+|(?=\.\d+))                  # No leading digits only if '.moreDigits' follows
         (?:\.|(?=[eE]))                        # There may be no floating point only if an exponent is present
         \d*                                    # Zero or more floating digits
         ([eE][+-]?\d+)?                        # expontent
         [lLfF]?                                # Suffix
        )/x)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [/(?:\\d+|(?=\\.\\d+))                  # No leading digits only if '.moreDigits' follows
         (?:\\.|(?=[eE]))                        # There may be no floating point only if an exponent is present
         \\d*                                    # Zero or more floating digits
         ([eE][+-]?\\d+)?                        # expontent
         [lLfF]?                                # Suffix
        /x]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{FLOATING_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{FLOATING_CONSTANT},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{FLOATING_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{FLOATING_CONSTANT},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{FLOATING_CONSTANT},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::IDENTIFIER
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"IDENTIFIER"};

    TestParser::_Runtime::_trace(q{Trying rule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{IDENTIFIER},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{/(?!(auto|break|case|char|const|continue|default|do|double|else|enum|extern|float|for|goto      # LOOKAHEAD FOR KEYWORDS
            |if|int|long|register|return|signed|sizeof|short|static|struct|switch|typedef           # NONE OF THE KEYWORDS
            |union|unsigned|void|volatile|while)[^a-zA-Z_])                                             # SHOULD FULLY MATCH!
            (([a-zA-Z]\\w*)|(_\\w+))/x});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [/(?!(auto|break|case|char|const|continue|default|do|double|else|enum|extern|float|for|goto      # LOOKAHEAD FOR KEYWORDS
            |if|int|long|register|return|signed|sizeof|short|static|struct|switch|typedef           # NONE OF THE KEYWORDS
            |union|unsigned|void|volatile|while)[^a-zA-Z_])                                             # SHOULD FULLY MATCH!
            (([a-zA-Z]\\w*)|(_\\w+))/x]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{IDENTIFIER},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{IDENTIFIER});
        %item = (__RULE__ => q{IDENTIFIER});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: [/(?!(auto|break|case|char|const|continue|default|do|double|else|enum|extern|float|for|goto      # LOOKAHEAD FOR KEYWORDS
            |if|int|long|register|return|signed|sizeof|short|static|struct|switch|typedef           # NONE OF THE KEYWORDS
            |union|unsigned|void|volatile|while)[^a-zA-Z_])                                             # SHOULD FULLY MATCH!
            (([a-zA-Z]\\w*)|(_\\w+))/x]}, TestParser::_Runtime::_tracefirst($text),
                      q{IDENTIFIER},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(?!(auto|break|case|char|const|continue|default|do|double|else|enum|extern|float|for|goto      # LOOKAHEAD FOR KEYWORDS
            |if|int|long|register|return|signed|sizeof|short|static|struct|switch|typedef           # NONE OF THE KEYWORDS
            |union|unsigned|void|volatile|while)[^a-zA-Z_])                                             # SHOULD FULLY MATCH!
            (([a-zA-Z]\w*)|(_\w+)))/x)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [/(?!(auto|break|case|char|const|continue|default|do|double|else|enum|extern|float|for|goto      # LOOKAHEAD FOR KEYWORDS
            |if|int|long|register|return|signed|sizeof|short|static|struct|switch|typedef           # NONE OF THE KEYWORDS
            |union|unsigned|void|volatile|while)[^a-zA-Z_])                                             # SHOULD FULLY MATCH!
            (([a-zA-Z]\\w*)|(_\\w+))/x]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{IDENTIFIER},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{IDENTIFIER},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{IDENTIFIER},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{IDENTIFIER},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{IDENTIFIER},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::INTEGER_CONSTANT
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"INTEGER_CONSTANT"};

    TestParser::_Runtime::_trace(q{Trying rule: [INTEGER_CONSTANT]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{INTEGER_CONSTANT},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{/(?:0[xX][\\da-fA-F]+)                   # Hexadecimal
         |(?:0[0-7]*)                           # Octal or Zero
         |(?:[1-9]\\d*)                          # Decimal
         [uUlL]?                                # Suffix
         /x});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [/(?:0[xX][\\da-fA-F]+)                   # Hexadecimal
         |(?:0[0-7]*)                           # Octal or Zero
         |(?:[1-9]\\d*)                          # Decimal
         [uUlL]?                                # Suffix
         /x]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{INTEGER_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{INTEGER_CONSTANT});
        %item = (__RULE__ => q{INTEGER_CONSTANT});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: [/(?:0[xX][\\da-fA-F]+)                   # Hexadecimal
         |(?:0[0-7]*)                           # Octal or Zero
         |(?:[1-9]\\d*)                          # Decimal
         [uUlL]?                                # Suffix
         /x]}, TestParser::_Runtime::_tracefirst($text),
                      q{INTEGER_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(?:0[xX][\da-fA-F]+)                   # Hexadecimal
         |(?:0[0-7]*)                           # Octal or Zero
         |(?:[1-9]\d*)                          # Decimal
         [uUlL]?                                # Suffix
         )/x)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [/(?:0[xX][\\da-fA-F]+)                   # Hexadecimal
         |(?:0[0-7]*)                           # Octal or Zero
         |(?:[1-9]\\d*)                          # Decimal
         [uUlL]?                                # Suffix
         /x]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{INTEGER_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{INTEGER_CONSTANT},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{INTEGER_CONSTANT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{INTEGER_CONSTANT},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{INTEGER_CONSTANT},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::STRING
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"STRING"};

    TestParser::_Runtime::_trace(q{Trying rule: [STRING]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{STRING},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{/"(([^\\\\'"])                            # None of these
        |(\\\\[\\\\ntvbrfa'"])                  # or a backslash followed by one of those
        |(\\\\[0-7]\{1,3\})|(\\\\x\\d+))*"/x});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [/"(([^\\\\'"])                            # None of these
        |(\\\\[\\\\ntvbrfa'"])                  # or a backslash followed by one of those
        |(\\\\[0-7]\{1,3\})|(\\\\x\\d+))*"/x]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{STRING},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{STRING});
        %item = (__RULE__ => q{STRING});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: [/"(([^\\\\'"])                            # None of these
        |(\\\\[\\\\ntvbrfa'"])                  # or a backslash followed by one of those
        |(\\\\[0-7]\{1,3\})|(\\\\x\\d+))*"/x]}, TestParser::_Runtime::_tracefirst($text),
                      q{STRING},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:"(([^\\'"])                            # None of these
        |(\\[\\ntvbrfa'"])                  # or a backslash followed by one of those
        |(\\[0-7]{1,3})|(\\x\d+))*")/x)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [/"(([^\\\\'"])                            # None of these
        |(\\\\[\\\\ntvbrfa'"])                  # or a backslash followed by one of those
        |(\\\\[0-7]\{1,3\})|(\\\\x\\d+))*"/x]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{STRING},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{STRING},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{STRING},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{STRING},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{STRING},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::UNARY_OPERATOR
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"UNARY_OPERATOR"};

    TestParser::_Runtime::_trace(q{Trying rule: [UNARY_OPERATOR]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{UNARY_OPERATOR},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'&', or '*', or '+', or '-', or '~', or '!'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['&']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{UNARY_OPERATOR});
        %item = (__RULE__ => q{UNARY_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['&']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\&/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['&']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['*']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{UNARY_OPERATOR});
        %item = (__RULE__ => q{UNARY_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['*']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\*/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['*']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['+']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{UNARY_OPERATOR});
        %item = (__RULE__ => q{UNARY_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['+']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\+/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['+']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['-']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{UNARY_OPERATOR});
        %item = (__RULE__ => q{UNARY_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['-']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\-/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['-']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['~']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{UNARY_OPERATOR});
        %item = (__RULE__ => q{UNARY_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['~']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\~/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['~']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['!']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{UNARY_OPERATOR});
        %item = (__RULE__ => q{UNARY_OPERATOR});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['!']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\!/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['!']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{UNARY_OPERATOR},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{UNARY_OPERATOR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{UNARY_OPERATOR},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{UNARY_OPERATOR},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::_alternation_1_of_production_1_of_rule_conditional_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule_conditional_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule_conditional_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule_conditional_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'?'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['?' expression ':' conditional_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_conditional_expression});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_conditional_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['?']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\?/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_conditional_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_conditional_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [':']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{':'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\:/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [conditional_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_conditional_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{conditional_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::conditional_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [conditional_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_conditional_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [conditional_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{conditional_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['?' expression ':' conditional_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule_conditional_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule_conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule_conditional_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule_conditional_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::_alternation_1_of_production_1_of_rule_enumerator
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule_enumerator"};

    TestParser::_Runtime::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule_enumerator]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule_enumerator},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'='});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['=' constant_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_enumerator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_enumerator});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_enumerator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_enumerator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [constant_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_enumerator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{constant_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::constant_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [constant_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_enumerator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [constant_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_enumerator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{constant_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['=' constant_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_enumerator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule_enumerator},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule_enumerator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule_enumerator},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule_enumerator},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::_alternation_1_of_production_1_of_rule_parameter_type_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule_parameter_type_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule_parameter_type_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule_parameter_type_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{','});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [',' '...']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_parameter_type_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_parameter_type_list});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_parameter_type_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: [',']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_parameter_type_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\,/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying terminal: ['...']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_parameter_type_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'...'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\.\.\./)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [',' '...']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_parameter_type_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule_parameter_type_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule_parameter_type_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule_parameter_type_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule_parameter_type_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::_alternation_1_of_production_1_of_rule_selection_statement
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule_selection_statement"};

    TestParser::_Runtime::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule_selection_statement]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule_selection_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'else'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['else' statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_selection_statement});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_selection_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['else']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aelse/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_selection_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{statement})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_selection_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['else' statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule_selection_statement},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule_selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule_selection_statement},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule_selection_statement},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::_alternation_1_of_production_2_of_rule_initializer
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_2_of_rule_initializer"};

    TestParser::_Runtime::_trace(q{Trying rule: [_alternation_1_of_production_2_of_rule_initializer]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{_alternation_1_of_production_2_of_rule_initializer},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{','});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [',']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{_alternation_1_of_production_2_of_rule_initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_2_of_rule_initializer});
        %item = (__RULE__ => q{_alternation_1_of_production_2_of_rule_initializer});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: [',']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_2_of_rule_initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\,/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [',']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{_alternation_1_of_production_2_of_rule_initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{_alternation_1_of_production_2_of_rule_initializer},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_2_of_rule_initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_2_of_rule_initializer},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{_alternation_1_of_production_2_of_rule_initializer},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::abstract_declarator
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"abstract_declarator"};

    TestParser::_Runtime::_trace(q{Trying rule: [abstract_declarator]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{abstract_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{pointer});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [pointer direct_abstract_declarator]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{abstract_declarator});
        %item = (__RULE__ => q{abstract_declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [pointer]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{abstract_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::pointer, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [pointer]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{abstract_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [pointer]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{pointer(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying subrule: [direct_abstract_declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{abstract_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{direct_abstract_declarator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::direct_abstract_declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [direct_abstract_declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{abstract_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [direct_abstract_declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{direct_abstract_declarator}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [pointer direct_abstract_declarator]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [pointer]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{abstract_declarator});
        %item = (__RULE__ => q{abstract_declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [pointer]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{abstract_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::pointer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [pointer]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{abstract_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [pointer]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{pointer}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [pointer]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{abstract_declarator},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{abstract_declarator},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{abstract_declarator},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::abstract_type
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"abstract_type"};

    TestParser::_Runtime::_trace(q{Trying rule: [abstract_type]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{abstract_type},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'[', or '('});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['[' constant_expression ']']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{abstract_type});
        %item = (__RULE__ => q{abstract_type});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['[']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [constant_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{abstract_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{constant_expression})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::constant_expression, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [constant_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{abstract_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [constant_expression]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{constant_expression(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [']']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{']'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['[' constant_expression ']']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['(' parameter_type_list ')']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{abstract_type});
        %item = (__RULE__ => q{abstract_type});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [parameter_type_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{abstract_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{parameter_type_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::parameter_type_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [parameter_type_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{abstract_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [parameter_type_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{parameter_type_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['(' parameter_type_list ')']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{abstract_type},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{abstract_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{abstract_type},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{abstract_type},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::additive_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"additive_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [additive_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{additive_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: multiplicative_expression /(\\+|-)/ multiplicative_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: multiplicative_expression /(\\+|-)/ multiplicative_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{additive_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{additive_expression});
        %item = (__RULE__ => q{additive_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: multiplicative_expression /(\\+|-)/ multiplicative_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{additive_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [multiplicative_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{additive_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{multiplicative_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::multiplicative_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [multiplicative_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{additive_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [multiplicative_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{additive_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{multiplicative_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(\\+|-)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{additive_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(\\+|-)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(\+|-))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'multiplicative_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [multiplicative_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{additive_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{multiplicative_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::multiplicative_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [multiplicative_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{additive_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [multiplicative_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{additive_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{multiplicative_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: multiplicative_expression /(\\+|-)/ multiplicative_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{additive_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: multiplicative_expression /(\\+|-)/ multiplicative_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{additive_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'multiplicative_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: multiplicative_expression /(\\+|-)/ multiplicative_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{additive_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{additive_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{additive_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{additive_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{additive_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::argument_expression_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"argument_expression_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [argument_expression_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{argument_expression_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: assignment_expression /(,)/ assignment_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: assignment_expression /(,)/ assignment_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{argument_expression_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{argument_expression_list});
        %item = (__RULE__ => q{argument_expression_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: assignment_expression /(,)/ assignment_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{argument_expression_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [assignment_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{argument_expression_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{assignment_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::assignment_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [assignment_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{argument_expression_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [assignment_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{argument_expression_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{assignment_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(,)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{argument_expression_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(,)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(,))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'assignment_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [assignment_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{argument_expression_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{assignment_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::assignment_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [assignment_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{argument_expression_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [assignment_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{argument_expression_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{assignment_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: assignment_expression /(,)/ assignment_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{argument_expression_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: assignment_expression /(,)/ assignment_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{argument_expression_list},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'assignment_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: assignment_expression /(,)/ assignment_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{argument_expression_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{argument_expression_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{argument_expression_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{argument_expression_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{argument_expression_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::assignment_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"assignment_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [assignment_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{assignment_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{unary_expression, or conditional_expression});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [unary_expression ASSIGNMENT_OPERATOR assignment_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{assignment_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{assignment_expression});
        %item = (__RULE__ => q{assignment_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [unary_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{assignment_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::unary_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [unary_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{assignment_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [unary_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{assignment_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{unary_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying subrule: [ASSIGNMENT_OPERATOR]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{assignment_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{ASSIGNMENT_OPERATOR})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::ASSIGNMENT_OPERATOR($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [ASSIGNMENT_OPERATOR]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{assignment_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [ASSIGNMENT_OPERATOR]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{assignment_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ASSIGNMENT_OPERATOR}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying subrule: [assignment_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{assignment_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{assignment_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::assignment_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [assignment_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{assignment_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [assignment_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{assignment_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{assignment_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [unary_expression ASSIGNMENT_OPERATOR assignment_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{assignment_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [conditional_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{assignment_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{assignment_expression});
        %item = (__RULE__ => q{assignment_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [conditional_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{assignment_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::conditional_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [conditional_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{assignment_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [conditional_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{assignment_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{conditional_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [conditional_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{assignment_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{assignment_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{assignment_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{assignment_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{assignment_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::cast_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"cast_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [cast_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{cast_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{unary_expression, or '('});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [unary_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{cast_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{cast_expression});
        %item = (__RULE__ => q{cast_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [unary_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{cast_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::unary_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [unary_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{cast_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [unary_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{cast_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{unary_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [unary_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{cast_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['(' type_name ')' cast_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{cast_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{cast_expression});
        %item = (__RULE__ => q{cast_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{cast_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [type_name]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{cast_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{type_name})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::type_name($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [type_name]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{cast_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [type_name]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{cast_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type_name}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{cast_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [cast_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{cast_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{cast_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::cast_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [cast_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{cast_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [cast_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{cast_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{cast_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['(' type_name ')' cast_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{cast_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{cast_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{cast_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{cast_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{cast_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::compound_statement
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"compound_statement"};

    TestParser::_Runtime::_trace(q{Trying rule: [compound_statement]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{compound_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'\{'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['\{' declaration_list statement_list '\}']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{compound_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{compound_statement});
        %item = (__RULE__ => q{compound_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['\{']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{compound_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\{/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [declaration_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{compound_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{declaration_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::declaration_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [declaration_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{compound_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [declaration_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{compound_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [statement_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{compound_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{statement_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::statement_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [statement_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{compound_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [statement_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{compound_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: ['\}']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{compound_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'\}'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\}/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['\{' declaration_list statement_list '\}']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{compound_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{compound_statement},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{compound_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{compound_statement},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{compound_statement},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::conditional_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"conditional_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [conditional_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{conditional_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{logical_OR_expression});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [logical_OR_expression '?']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{conditional_expression});
        %item = (__RULE__ => q{conditional_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [logical_OR_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{conditional_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::logical_OR_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [logical_OR_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{conditional_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [logical_OR_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{logical_OR_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: ['?']},
                  TestParser::_Runtime::_tracefirst($text),
                  q{conditional_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{'?'})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::_alternation_1_of_production_1_of_rule_conditional_expression, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: ['?']>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{conditional_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [_alternation_1_of_production_1_of_rule_conditional_expression]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule_conditional_expression(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [logical_OR_expression '?']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{conditional_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{conditional_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{conditional_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{conditional_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::constant
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"constant"};

    TestParser::_Runtime::_trace(q{Trying rule: [constant]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{constant},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{CHARACTER_CONSTANT, or FLOATING_CONSTANT, or INTEGER_CONSTANT, or ENUMERATION_CONSTANT});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [CHARACTER_CONSTANT]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{constant});
        %item = (__RULE__ => q{constant});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [CHARACTER_CONSTANT]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{constant},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::CHARACTER_CONSTANT($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [CHARACTER_CONSTANT]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{constant},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [CHARACTER_CONSTANT]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{CHARACTER_CONSTANT}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [CHARACTER_CONSTANT]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [FLOATING_CONSTANT]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{constant});
        %item = (__RULE__ => q{constant});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [FLOATING_CONSTANT]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{constant},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::FLOATING_CONSTANT($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [FLOATING_CONSTANT]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{constant},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [FLOATING_CONSTANT]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{FLOATING_CONSTANT}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [FLOATING_CONSTANT]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [INTEGER_CONSTANT]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{constant});
        %item = (__RULE__ => q{constant});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [INTEGER_CONSTANT]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{constant},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::INTEGER_CONSTANT($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [INTEGER_CONSTANT]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{constant},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [INTEGER_CONSTANT]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{INTEGER_CONSTANT}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [INTEGER_CONSTANT]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [ENUMERATION_CONSTANT]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{constant});
        %item = (__RULE__ => q{constant});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [ENUMERATION_CONSTANT]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{constant},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::ENUMERATION_CONSTANT($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [ENUMERATION_CONSTANT]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{constant},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [ENUMERATION_CONSTANT]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ENUMERATION_CONSTANT}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [ENUMERATION_CONSTANT]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{constant},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{constant},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{constant},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{constant},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::constant_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"constant_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [constant_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{constant_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{conditional_expression});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [conditional_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{constant_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{constant_expression});
        %item = (__RULE__ => q{constant_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [conditional_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{constant_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::conditional_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [conditional_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{constant_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [conditional_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{constant_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{conditional_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [conditional_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{constant_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{constant_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{constant_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{constant_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{constant_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::declaration
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"declaration"};

    TestParser::_Runtime::_trace(q{Trying rule: [declaration]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{declaration_specifiers});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declaration_specifiers init_declarator_list ';']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{declaration});
        %item = (__RULE__ => q{declaration});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [declaration_specifiers]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declaration_specifiers($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declaration_specifiers]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declaration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declaration_specifiers]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration_specifiers}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [init_declarator_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{init_declarator_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::init_declarator_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [init_declarator_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declaration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [init_declarator_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{init_declarator_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [';']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{';'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\;/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying action},
                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
            if($::opt_DECLARATIONS)
            {
                $::declarations_output .= ::flatten_list($item[1]);
                $::declarations_output .= ::flatten_list($item[2]);
                $::declarations_output .= ::flatten_list($item[3]) . "\n";
            }
        };
        unless (defined $_tok)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      TestParser::_Runtime::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [declaration_specifiers init_declarator_list ';']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{declaration},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{declaration},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{declaration},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::declaration_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"declaration_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [declaration_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{declaration_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{declaration});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declaration]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{declaration_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{declaration_list});
        %item = (__RULE__ => q{declaration_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [declaration]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declaration_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::declaration, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [declaration]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declaration_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [declaration]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration(s)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [declaration]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{declaration_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{declaration_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{declaration_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{declaration_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::declaration_specifiers
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"declaration_specifiers"};

    TestParser::_Runtime::_trace(q{Trying rule: [declaration_specifiers]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{declaration_specifiers},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{type_qualifier, or storage_class_specifier, or type_specifier});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [type_qualifier declaration_specifiers]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{declaration_specifiers});
        %item = (__RULE__ => q{declaration_specifiers});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [type_qualifier]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declaration_specifiers},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::type_qualifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [type_qualifier]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declaration_specifiers},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [type_qualifier]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type_qualifier}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [declaration_specifiers]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declaration_specifiers},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{declaration_specifiers})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::declaration_specifiers, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [declaration_specifiers]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declaration_specifiers},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [declaration_specifiers]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration_specifiers(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [type_qualifier declaration_specifiers]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [storage_class_specifier declaration_specifiers]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{declaration_specifiers});
        %item = (__RULE__ => q{declaration_specifiers});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [storage_class_specifier]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declaration_specifiers},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::storage_class_specifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [storage_class_specifier]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declaration_specifiers},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [storage_class_specifier]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{storage_class_specifier}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [declaration_specifiers]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declaration_specifiers},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{declaration_specifiers})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::declaration_specifiers, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [declaration_specifiers]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declaration_specifiers},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [declaration_specifiers]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration_specifiers(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [storage_class_specifier declaration_specifiers]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [type_specifier declaration_specifiers]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{declaration_specifiers});
        %item = (__RULE__ => q{declaration_specifiers});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [type_specifier]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declaration_specifiers},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::type_specifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [type_specifier]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declaration_specifiers},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [type_specifier]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type_specifier}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [declaration_specifiers]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declaration_specifiers},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{declaration_specifiers})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::declaration_specifiers, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [declaration_specifiers]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declaration_specifiers},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [declaration_specifiers]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration_specifiers(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [type_specifier declaration_specifiers]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{declaration_specifiers},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{declaration_specifiers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{declaration_specifiers},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{declaration_specifiers},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::declarator
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"declarator"};

    TestParser::_Runtime::_trace(q{Trying rule: [declarator]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{pointer});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [pointer direct_declarator]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{declarator});
        %item = (__RULE__ => q{declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [pointer]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::pointer, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [pointer]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [pointer]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{pointer(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying subrule: [direct_declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{direct_declarator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::direct_declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [direct_declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [direct_declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{direct_declarator}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [pointer direct_declarator]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{declarator},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{declarator},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{declarator},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::direct_abstract_declarator
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"direct_abstract_declarator"};

    TestParser::_Runtime::_trace(q{Trying rule: [direct_abstract_declarator]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{direct_abstract_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'(', or abstract_type});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['(' abstract_declarator ')' abstract_type]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{direct_abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{direct_abstract_declarator});
        %item = (__RULE__ => q{direct_abstract_declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [abstract_declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{direct_abstract_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{abstract_declarator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::abstract_declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [abstract_declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{direct_abstract_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [abstract_declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{abstract_declarator}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [abstract_type]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{direct_abstract_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{abstract_type})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::abstract_type, 0, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [abstract_type]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{direct_abstract_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [abstract_type]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{abstract_type(s?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: ['(' abstract_declarator ')' abstract_type]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [abstract_type]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{direct_abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{direct_abstract_declarator});
        %item = (__RULE__ => q{direct_abstract_declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [abstract_type]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{direct_abstract_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::abstract_type, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [abstract_type]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{direct_abstract_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [abstract_type]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{abstract_type(s)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [abstract_type]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{direct_abstract_declarator},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{direct_abstract_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{direct_abstract_declarator},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{direct_abstract_declarator},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::direct_declarator
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"direct_declarator"};

    TestParser::_Runtime::_trace(q{Trying rule: [direct_declarator]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{direct_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{IDENTIFIER, or '('});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [IDENTIFIER function_signature]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{direct_declarator});
        %item = (__RULE__ => q{direct_declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{direct_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{direct_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [function_signature]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{direct_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{function_signature})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::function_signature, 0, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [function_signature]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{direct_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [function_signature]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{function_signature(s?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [IDENTIFIER function_signature]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['(' declarator ')' function_signature]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{direct_declarator});
        %item = (__RULE__ => q{direct_declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{direct_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{declarator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{direct_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declarator}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [function_signature]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{direct_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{function_signature})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::function_signature, 0, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [function_signature]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{direct_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [function_signature]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{function_signature(s?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: ['(' declarator ')' function_signature]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{direct_declarator},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{direct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{direct_declarator},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{direct_declarator},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::enum_specifier
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"enum_specifier"};

    TestParser::_Runtime::_trace(q{Trying rule: [enum_specifier]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{enum_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'enum'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['enum' IDENTIFIER '\{' enumerator_list '\}']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{enum_specifier});
        %item = (__RULE__ => q{enum_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['enum']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aenum/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{enum_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{IDENTIFIER})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::IDENTIFIER, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{enum_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [IDENTIFIER]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: ['\{']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'\{'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\{/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [enumerator_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{enum_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{enumerator_list})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::enumerator_list($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [enumerator_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{enum_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [enumerator_list]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{enumerator_list}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: ['\}']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'\}'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\}/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING3__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying action},
                      TestParser::_Runtime::_tracefirst($text),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
            if($::opt_STRUCTS){
                $::structs_output .= ::flatten_list($item[1]) . " ";
                $::structs_output .= ::flatten_list($item[2]);
                $::structs_output .= ::flatten_list($item[3]) . "\n";
                $::structs_output .= ::flatten_list_beautified($item[4]);
                $::structs_output .= ::flatten_list($item[5]) . ";\n\n";
            }
          };
        unless (defined $_tok)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      TestParser::_Runtime::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['enum' IDENTIFIER '\{' enumerator_list '\}']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['enum' IDENTIFIER]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{enum_specifier});
        %item = (__RULE__ => q{enum_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['enum']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aenum/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{enum_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{IDENTIFIER})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{enum_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['enum' IDENTIFIER]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{enum_specifier},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{enum_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{enum_specifier},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{enum_specifier},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::enumerator
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"enumerator"};

    TestParser::_Runtime::_trace(q{Trying rule: [enumerator]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{enumerator},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{IDENTIFIER});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [IDENTIFIER '=']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{enumerator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{enumerator});
        %item = (__RULE__ => q{enumerator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{enumerator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{enumerator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{enumerator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: ['=']},
                  TestParser::_Runtime::_tracefirst($text),
                  q{enumerator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{'='})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::_alternation_1_of_production_1_of_rule_enumerator, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: ['=']>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{enumerator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [_alternation_1_of_production_1_of_rule_enumerator]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{enumerator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule_enumerator(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [IDENTIFIER '=']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{enumerator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{enumerator},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{enumerator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{enumerator},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{enumerator},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::enumerator_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"enumerator_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [enumerator_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{enumerator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: enumerator /(,)/ enumerator>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: enumerator /(,)/ enumerator>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{enumerator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{enumerator_list});
        %item = (__RULE__ => q{enumerator_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: enumerator /(,)/ enumerator>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{enumerator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [enumerator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{enumerator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{enumerator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::enumerator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [enumerator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{enumerator_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [enumerator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{enumerator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{enumerator}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(,)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{enumerator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(,)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(,))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'enumerator(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [enumerator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{enumerator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{enumerator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::enumerator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [enumerator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{enumerator_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [enumerator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{enumerator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{enumerator}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: enumerator /(,)/ enumerator>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{enumerator_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: enumerator /(,)/ enumerator>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{enumerator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'enumerator(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: enumerator /(,)/ enumerator>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{enumerator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{enumerator_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{enumerator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{enumerator_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{enumerator_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::equality_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"equality_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [equality_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{equality_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: relational_expression /(==|!=)/ relational_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: relational_expression /(==|!=)/ relational_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{equality_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{equality_expression});
        %item = (__RULE__ => q{equality_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: relational_expression /(==|!=)/ relational_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{equality_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [relational_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{equality_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{relational_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::relational_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [relational_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{equality_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [relational_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{equality_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{relational_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(==|!=)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{equality_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(==|!=)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(==|!=))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'relational_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [relational_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{equality_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{relational_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::relational_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [relational_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{equality_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [relational_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{equality_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{relational_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: relational_expression /(==|!=)/ relational_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{equality_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: relational_expression /(==|!=)/ relational_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{equality_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'relational_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: relational_expression /(==|!=)/ relational_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{equality_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{equality_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{equality_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{equality_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{equality_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::exclusive_OR_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"exclusive_OR_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [exclusive_OR_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{exclusive_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: AND_expression /(\\^)/ AND_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: AND_expression /(\\^)/ AND_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{exclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{exclusive_OR_expression});
        %item = (__RULE__ => q{exclusive_OR_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: AND_expression /(\\^)/ AND_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{exclusive_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [AND_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{exclusive_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{AND_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::AND_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [AND_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{exclusive_OR_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [AND_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{exclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{AND_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(\\^)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{exclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(\\^)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(\^))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'AND_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [AND_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{exclusive_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{AND_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::AND_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [AND_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{exclusive_OR_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [AND_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{exclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{AND_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: AND_expression /(\\^)/ AND_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{exclusive_OR_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: AND_expression /(\\^)/ AND_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{exclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'AND_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: AND_expression /(\\^)/ AND_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{exclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{exclusive_OR_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{exclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{exclusive_OR_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{exclusive_OR_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: assignment_expression /(,)/ assignment_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: assignment_expression /(,)/ assignment_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{expression});
        %item = (__RULE__ => q{expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: assignment_expression /(,)/ assignment_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [assignment_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{assignment_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::assignment_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [assignment_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [assignment_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{assignment_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(,)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(,)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(,))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'assignment_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [assignment_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{assignment_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::assignment_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [assignment_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [assignment_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{assignment_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: assignment_expression /(,)/ assignment_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: assignment_expression /(,)/ assignment_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'assignment_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: assignment_expression /(,)/ assignment_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::expression_statement
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"expression_statement"};

    TestParser::_Runtime::_trace(q{Trying rule: [expression_statement]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{expression_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{expression});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [expression ';']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{expression_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{expression_statement});
        %item = (__RULE__ => q{expression_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{expression_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::expression, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{expression_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [expression]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{expression_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [';']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{expression_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{';'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\;/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [expression ';']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{expression_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{expression_statement},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{expression_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{expression_statement},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{expression_statement},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::external_declaration
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"external_declaration"};

    TestParser::_Runtime::_trace(q{Trying rule: [external_declaration]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{external_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{function_definition, or declaration});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [function_definition]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{external_declaration});
        %item = (__RULE__ => q{external_declaration});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [function_definition]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{external_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::function_definition($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [function_definition]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{external_declaration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [function_definition]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{function_definition}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [function_definition]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declaration]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{external_declaration});
        %item = (__RULE__ => q{external_declaration});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [declaration]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{external_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declaration($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declaration]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{external_declaration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declaration]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [declaration]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<resync>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{external_declaration});
        %item = (__RULE__ => q{external_declaration});
        my $repcount = 0;


        

        TestParser::_Runtime::_trace(q{Trying directive: [<resync>]},
                    TestParser::_Runtime::_tracefirst($text),
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($text =~ s/(\A[^\n]*\n)//) { $return = 0; $1; } else { undef } };
        if (defined($_tok))
        {
            TestParser::_Runtime::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            TestParser::_Runtime::_trace(q{<<Didn't match directive>>},
                        TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        TestParser::_Runtime::_trace(q{Trying action},
                      TestParser::_Runtime::_tracefirst($text),
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
            if ($::opt_SKIPPEDLINES || (defined $::opt_VERBOSE and $::opt_VERBOSE >= 1 ))
            {
                print "Skipping line $thisline\n"   # Try next line if possible...
            }
         };
        unless (defined $_tok)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      TestParser::_Runtime::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [<resync>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{external_declaration},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{external_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{external_declaration},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{external_declaration},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::function_definition
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"function_definition"};

    TestParser::_Runtime::_trace(q{Trying rule: [function_definition]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{function_definition},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{declaration_specifiers});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declaration_specifiers declarator declaration_list compound_statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{function_definition},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{function_definition});
        %item = (__RULE__ => q{function_definition});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [declaration_specifiers]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{function_definition},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::declaration_specifiers, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [declaration_specifiers]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{function_definition},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [declaration_specifiers]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{function_definition},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration_specifiers(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying subrule: [declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{function_definition},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{declarator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{function_definition},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{function_definition},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declarator}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [declaration_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{function_definition},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{declaration_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::declaration_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [declaration_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{function_definition},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [declaration_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{function_definition},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying subrule: [compound_statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{function_definition},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{compound_statement})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::compound_statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [compound_statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{function_definition},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [compound_statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{function_definition},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{compound_statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying action},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_definition},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
            if($::opt_FUNCTIONS)
            {
                $::functions_output .= ::flatten_list($item[1]);
                $::functions_output .= ::flatten_list($item[2]);
                $::functions_output .= ::flatten_list($item[3]) . ";\n";
            }
        };
        unless (defined $_tok)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      TestParser::_Runtime::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [declaration_specifiers declarator declaration_list compound_statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_definition},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{function_definition},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{function_definition},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{function_definition},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{function_definition},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::function_signature
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"function_signature"};

    TestParser::_Runtime::_trace(q{Trying rule: [function_signature]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{function_signature},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'[', or '('});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['[' constant_expression ']']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{function_signature});
        %item = (__RULE__ => q{function_signature});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['[']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [constant_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{function_signature},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{constant_expression})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::constant_expression, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [constant_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{function_signature},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [constant_expression]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{constant_expression(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [']']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{']'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['[' constant_expression ']']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['(' parameter_type_list ')']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{function_signature});
        %item = (__RULE__ => q{function_signature});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [parameter_type_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{function_signature},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{parameter_type_list})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::parameter_type_list($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [parameter_type_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{function_signature},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [parameter_type_list]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{parameter_type_list}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['(' parameter_type_list ')']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['(' identifier_list ')']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{function_signature});
        %item = (__RULE__ => q{function_signature});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [identifier_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{function_signature},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{identifier_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::identifier_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [identifier_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{function_signature},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [identifier_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{identifier_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['(' identifier_list ')']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{function_signature},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{function_signature},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{function_signature},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{function_signature},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::identifier_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"identifier_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [identifier_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{identifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: IDENTIFIER /(,)/ IDENTIFIER>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: IDENTIFIER /(,)/ IDENTIFIER>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{identifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{identifier_list});
        %item = (__RULE__ => q{identifier_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: IDENTIFIER /(,)/ IDENTIFIER>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{identifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{identifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{IDENTIFIER})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{identifier_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{identifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(,)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{identifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(,)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(,))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'IDENTIFIER(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{identifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{IDENTIFIER})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{identifier_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{identifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: IDENTIFIER /(,)/ IDENTIFIER>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{identifier_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: IDENTIFIER /(,)/ IDENTIFIER>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{identifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'IDENTIFIER(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: IDENTIFIER /(,)/ IDENTIFIER>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{identifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{identifier_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{identifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{identifier_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{identifier_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::inclusive_OR_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"inclusive_OR_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [inclusive_OR_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{inclusive_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: exclusive_OR_expression /(\\|)/ exclusive_OR_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: exclusive_OR_expression /(\\|)/ exclusive_OR_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{inclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{inclusive_OR_expression});
        %item = (__RULE__ => q{inclusive_OR_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: exclusive_OR_expression /(\\|)/ exclusive_OR_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{inclusive_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [exclusive_OR_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{inclusive_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{exclusive_OR_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::exclusive_OR_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [exclusive_OR_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{inclusive_OR_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [exclusive_OR_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{inclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{exclusive_OR_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(\\|)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{inclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(\\|)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(\|))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'exclusive_OR_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [exclusive_OR_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{inclusive_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{exclusive_OR_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::exclusive_OR_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [exclusive_OR_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{inclusive_OR_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [exclusive_OR_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{inclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{exclusive_OR_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: exclusive_OR_expression /(\\|)/ exclusive_OR_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{inclusive_OR_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: exclusive_OR_expression /(\\|)/ exclusive_OR_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{inclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'exclusive_OR_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: exclusive_OR_expression /(\\|)/ exclusive_OR_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{inclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{inclusive_OR_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{inclusive_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{inclusive_OR_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{inclusive_OR_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::init_declarator
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"init_declarator"};

    TestParser::_Runtime::_trace(q{Trying rule: [init_declarator]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{init_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{declarator});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declarator '=' initializer]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{init_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{init_declarator});
        %item = (__RULE__ => q{init_declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{init_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{init_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declarator}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: ['=']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'='})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\=/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [initializer]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{init_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{initializer})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::initializer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [initializer]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{init_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [initializer]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{initializer}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [declarator '=' initializer]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declarator]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{init_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{init_declarator});
        %item = (__RULE__ => q{init_declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{init_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{init_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declarator}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [declarator]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{init_declarator},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{init_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{init_declarator},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{init_declarator},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::init_declarator_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"init_declarator_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [init_declarator_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{init_declarator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: init_declarator /(,)/ init_declarator>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: init_declarator /(,)/ init_declarator>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{init_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{init_declarator_list});
        %item = (__RULE__ => q{init_declarator_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: init_declarator /(,)/ init_declarator>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{init_declarator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [init_declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{init_declarator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{init_declarator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::init_declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [init_declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{init_declarator_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [init_declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{init_declarator}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(,)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(,)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(,))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'init_declarator(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [init_declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{init_declarator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{init_declarator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::init_declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [init_declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{init_declarator_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [init_declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{init_declarator}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: init_declarator /(,)/ init_declarator>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{init_declarator_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: init_declarator /(,)/ init_declarator>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'init_declarator(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: init_declarator /(,)/ init_declarator>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{init_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{init_declarator_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{init_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{init_declarator_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{init_declarator_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::initializer
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"initializer"};

    TestParser::_Runtime::_trace(q{Trying rule: [initializer]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{initializer},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{assignment_expression, or '\{'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [assignment_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{initializer});
        %item = (__RULE__ => q{initializer});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [assignment_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{initializer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::assignment_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [assignment_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{initializer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [assignment_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{assignment_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [assignment_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['\{' initializer_list ',' '\}']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{initializer});
        %item = (__RULE__ => q{initializer});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['\{']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\{/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [initializer_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{initializer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{initializer_list})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::initializer_list($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [initializer_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{initializer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [initializer_list]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{initializer_list}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [',']},
                  TestParser::_Runtime::_tracefirst($text),
                  q{initializer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{','})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::_alternation_1_of_production_2_of_rule_initializer, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [',']>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{initializer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [_alternation_1_of_production_2_of_rule_initializer]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_2_of_rule_initializer(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: ['\}']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'\}'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\}/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['\{' initializer_list ',' '\}']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{initializer},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{initializer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{initializer},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{initializer},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::initializer_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"initializer_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [initializer_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{initializer_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: initializer /(,)/ initializer>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: initializer /(,)/ initializer>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{initializer_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{initializer_list});
        %item = (__RULE__ => q{initializer_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: initializer /(,)/ initializer>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{initializer_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [initializer]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{initializer_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{initializer})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::initializer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [initializer]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{initializer_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [initializer]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{initializer}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(,)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{initializer_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(,)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(,))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'initializer(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [initializer]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{initializer_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{initializer})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::initializer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [initializer]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{initializer_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [initializer]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{initializer}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: initializer /(,)/ initializer>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{initializer_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: initializer /(,)/ initializer>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer_list},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'initializer(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: initializer /(,)/ initializer>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{initializer_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{initializer_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{initializer_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{initializer_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{initializer_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::iteration_statement
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"iteration_statement"};

    TestParser::_Runtime::_trace(q{Trying rule: [iteration_statement]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{iteration_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'for', or 'while', or 'do'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['for' '(' expression ';' expression ';' expression ')' statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{iteration_statement});
        %item = (__RULE__ => q{iteration_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['for']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Afor/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'('})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{iteration_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{expression})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::expression, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{iteration_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [expression]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [';']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{';'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\;/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING3__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{iteration_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{expression})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::expression, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{iteration_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [expression]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [';']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{';'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\;/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING4__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{iteration_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{expression})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::expression, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{iteration_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [expression]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING5__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{iteration_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{statement})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{iteration_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['for' '(' expression ';' expression ';' expression ')' statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['while' '(' expression ')' statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{iteration_statement});
        %item = (__RULE__ => q{iteration_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['while']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Awhile/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'('})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{iteration_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{iteration_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING3__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{iteration_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{statement})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{iteration_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['while' '(' expression ')' statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['do' statement 'while' '(' expression ')']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{iteration_statement});
        %item = (__RULE__ => q{iteration_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['do']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Ado/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{iteration_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{statement})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{iteration_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: ['while']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'while'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Awhile/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'('})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING3__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{iteration_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{iteration_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING4__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['do' statement 'while' '(' expression ')']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{iteration_statement},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{iteration_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{iteration_statement},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{iteration_statement},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::jump_statement
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"jump_statement"};

    TestParser::_Runtime::_trace(q{Trying rule: [jump_statement]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{jump_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'return', or 'break', or 'continue', or 'goto'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['return' expression ';']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{jump_statement});
        %item = (__RULE__ => q{jump_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['return']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Areturn/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{jump_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{expression})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::expression, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{jump_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [expression]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [';']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{';'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\;/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['return' expression ';']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['break' ';']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{jump_statement});
        %item = (__RULE__ => q{jump_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['break']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Abreak/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying terminal: [';']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{';'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\;/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['break' ';']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['continue' ';']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{jump_statement});
        %item = (__RULE__ => q{jump_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['continue']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Acontinue/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying terminal: [';']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{';'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\;/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['continue' ';']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['goto' IDENTIFIER ';']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{jump_statement});
        %item = (__RULE__ => q{jump_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['goto']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Agoto/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{jump_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{IDENTIFIER})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{jump_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [';']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{';'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\;/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['goto' IDENTIFIER ';']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{jump_statement},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{jump_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{jump_statement},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{jump_statement},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::labeled_statement
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"labeled_statement"};

    TestParser::_Runtime::_trace(q{Trying rule: [labeled_statement]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{labeled_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'case', or IDENTIFIER, or 'default'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['case' constant_expression ':' statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{labeled_statement});
        %item = (__RULE__ => q{labeled_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['case']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Acase/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [constant_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{labeled_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{constant_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::constant_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [constant_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{labeled_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [constant_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{constant_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [':']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{':'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\:/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{labeled_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{statement})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{labeled_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['case' constant_expression ':' statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [IDENTIFIER ':' statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{labeled_statement});
        %item = (__RULE__ => q{labeled_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{labeled_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{labeled_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [':']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{':'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\:/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{labeled_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{statement})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{labeled_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [IDENTIFIER ':' statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['default' ':' statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{labeled_statement});
        %item = (__RULE__ => q{labeled_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['default']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Adefault/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying terminal: [':']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{':'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\:/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{labeled_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{statement})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{labeled_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['default' ':' statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{labeled_statement},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{labeled_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{labeled_statement},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{labeled_statement},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::logical_AND_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"logical_AND_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [logical_AND_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{logical_AND_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: inclusive_OR_expression /(&&)/ inclusive_OR_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: inclusive_OR_expression /(&&)/ inclusive_OR_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{logical_AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{logical_AND_expression});
        %item = (__RULE__ => q{logical_AND_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: inclusive_OR_expression /(&&)/ inclusive_OR_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{logical_AND_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [inclusive_OR_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{logical_AND_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{inclusive_OR_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::inclusive_OR_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [inclusive_OR_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{logical_AND_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [inclusive_OR_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{logical_AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{inclusive_OR_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(&&)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{logical_AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(&&)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(&&))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'inclusive_OR_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [inclusive_OR_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{logical_AND_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{inclusive_OR_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::inclusive_OR_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [inclusive_OR_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{logical_AND_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [inclusive_OR_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{logical_AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{inclusive_OR_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: inclusive_OR_expression /(&&)/ inclusive_OR_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{logical_AND_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: inclusive_OR_expression /(&&)/ inclusive_OR_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{logical_AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'inclusive_OR_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: inclusive_OR_expression /(&&)/ inclusive_OR_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{logical_AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{logical_AND_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{logical_AND_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{logical_AND_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{logical_AND_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::logical_OR_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"logical_OR_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [logical_OR_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{logical_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: logical_AND_expression /(\\|\\|)/ logical_AND_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: logical_AND_expression /(\\|\\|)/ logical_AND_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{logical_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{logical_OR_expression});
        %item = (__RULE__ => q{logical_OR_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: logical_AND_expression /(\\|\\|)/ logical_AND_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{logical_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [logical_AND_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{logical_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{logical_AND_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::logical_AND_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [logical_AND_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{logical_OR_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [logical_AND_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{logical_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{logical_AND_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(\\|\\|)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{logical_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(\\|\\|)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(\|\|))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'logical_AND_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [logical_AND_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{logical_OR_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{logical_AND_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::logical_AND_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [logical_AND_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{logical_OR_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [logical_AND_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{logical_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{logical_AND_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: logical_AND_expression /(\\|\\|)/ logical_AND_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{logical_OR_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: logical_AND_expression /(\\|\\|)/ logical_AND_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{logical_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'logical_AND_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: logical_AND_expression /(\\|\\|)/ logical_AND_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{logical_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{logical_OR_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{logical_OR_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{logical_OR_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{logical_OR_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::multiplicative_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"multiplicative_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [multiplicative_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{multiplicative_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: cast_expression /(\\*|\\/|%)/ cast_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: cast_expression /(\\*|\\/|%)/ cast_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{multiplicative_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{multiplicative_expression});
        %item = (__RULE__ => q{multiplicative_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: cast_expression /(\\*|\\/|%)/ cast_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{multiplicative_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [cast_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{multiplicative_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{cast_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::cast_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [cast_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{multiplicative_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [cast_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{multiplicative_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{cast_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(\\*|\\/|%)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{multiplicative_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(\\*|\\/|%)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(\*|\/|%))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'cast_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [cast_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{multiplicative_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{cast_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::cast_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [cast_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{multiplicative_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [cast_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{multiplicative_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{cast_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: cast_expression /(\\*|\\/|%)/ cast_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{multiplicative_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: cast_expression /(\\*|\\/|%)/ cast_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{multiplicative_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'cast_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: cast_expression /(\\*|\\/|%)/ cast_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{multiplicative_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{multiplicative_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{multiplicative_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{multiplicative_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{multiplicative_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::parameter_declaration
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"parameter_declaration"};

    TestParser::_Runtime::_trace(q{Trying rule: [parameter_declaration]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{parameter_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{declaration_specifiers});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declaration_specifiers declarator]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{parameter_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{parameter_declaration});
        %item = (__RULE__ => q{parameter_declaration});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [declaration_specifiers]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{parameter_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declaration_specifiers($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declaration_specifiers]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{parameter_declaration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declaration_specifiers]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration_specifiers}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying subrule: [declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{parameter_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{declarator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{parameter_declaration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declarator}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [declaration_specifiers declarator]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declaration_specifiers abstract_declarator]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{parameter_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{parameter_declaration});
        %item = (__RULE__ => q{parameter_declaration});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [declaration_specifiers]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{parameter_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declaration_specifiers($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declaration_specifiers]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{parameter_declaration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declaration_specifiers]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declaration_specifiers}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [abstract_declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{parameter_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{abstract_declarator})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::abstract_declarator, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [abstract_declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{parameter_declaration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [abstract_declarator]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{abstract_declarator(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [declaration_specifiers abstract_declarator]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{parameter_declaration},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{parameter_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{parameter_declaration},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{parameter_declaration},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::parameter_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"parameter_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [parameter_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{parameter_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: parameter_declaration /(,)/ parameter_declaration>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: parameter_declaration /(,)/ parameter_declaration>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{parameter_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{parameter_list});
        %item = (__RULE__ => q{parameter_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: parameter_declaration /(,)/ parameter_declaration>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{parameter_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [parameter_declaration]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{parameter_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{parameter_declaration})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::parameter_declaration($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [parameter_declaration]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{parameter_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [parameter_declaration]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{parameter_declaration}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(,)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{parameter_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(,)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(,))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'parameter_declaration(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [parameter_declaration]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{parameter_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{parameter_declaration})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::parameter_declaration($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [parameter_declaration]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{parameter_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [parameter_declaration]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{parameter_declaration}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: parameter_declaration /(,)/ parameter_declaration>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{parameter_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: parameter_declaration /(,)/ parameter_declaration>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_list},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'parameter_declaration(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: parameter_declaration /(,)/ parameter_declaration>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{parameter_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{parameter_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{parameter_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{parameter_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::parameter_type_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"parameter_type_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [parameter_type_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{parameter_type_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{parameter_list});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [parameter_list ',']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{parameter_type_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{parameter_type_list});
        %item = (__RULE__ => q{parameter_type_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [parameter_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{parameter_type_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::parameter_list($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [parameter_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{parameter_type_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [parameter_list]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_type_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{parameter_list}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [',']},
                  TestParser::_Runtime::_tracefirst($text),
                  q{parameter_type_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{','})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::_alternation_1_of_production_1_of_rule_parameter_type_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [',']>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{parameter_type_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [_alternation_1_of_production_1_of_rule_parameter_type_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_type_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule_parameter_type_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [parameter_list ',']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{parameter_type_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{parameter_type_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{parameter_type_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{parameter_type_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{parameter_type_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::pointer
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"pointer"};

    TestParser::_Runtime::_trace(q{Trying rule: [pointer]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{pointer},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'*'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['*' type_qualifier_list pointer]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{pointer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{pointer});
        %item = (__RULE__ => q{pointer});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['*']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{pointer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\*/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [type_qualifier_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{pointer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{type_qualifier_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::type_qualifier_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [type_qualifier_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{pointer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [type_qualifier_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{pointer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type_qualifier_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [pointer]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{pointer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{pointer})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::pointer, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [pointer]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{pointer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [pointer]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{pointer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{pointer(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: ['*' type_qualifier_list pointer]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{pointer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{pointer},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{pointer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{pointer},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{pointer},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::postfix_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"postfix_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [postfix_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{postfix_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{primary_expression});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [primary_expression postfix_expression_token]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{postfix_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{postfix_expression});
        %item = (__RULE__ => q{postfix_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [primary_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{postfix_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::primary_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [primary_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{postfix_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [primary_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{primary_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [postfix_expression_token]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{postfix_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{postfix_expression_token})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::postfix_expression_token, 0, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [postfix_expression_token]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{postfix_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [postfix_expression_token]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{postfix_expression_token(s?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [primary_expression postfix_expression_token]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{postfix_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{postfix_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{postfix_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{postfix_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::postfix_expression_token
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"postfix_expression_token"};

    TestParser::_Runtime::_trace(q{Trying rule: [postfix_expression_token]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{postfix_expression_token},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'[', or '(', or '.', or '->', or '++', or '--'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['[' expression ']']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{postfix_expression_token});
        %item = (__RULE__ => q{postfix_expression_token});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['[']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{postfix_expression_token},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{postfix_expression_token},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [']']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{']'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['[' expression ']']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['(' argument_expression_list ')']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{postfix_expression_token});
        %item = (__RULE__ => q{postfix_expression_token});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [argument_expression_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{postfix_expression_token},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{argument_expression_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::argument_expression_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [argument_expression_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{postfix_expression_token},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [argument_expression_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{argument_expression_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['(' argument_expression_list ')']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['.' IDENTIFIER]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{postfix_expression_token});
        %item = (__RULE__ => q{postfix_expression_token});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['.']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\./)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{postfix_expression_token},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{IDENTIFIER})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{postfix_expression_token},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['.' IDENTIFIER]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['->' IDENTIFIER]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{postfix_expression_token});
        %item = (__RULE__ => q{postfix_expression_token});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['->']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\-\>/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{postfix_expression_token},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{IDENTIFIER})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{postfix_expression_token},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['->' IDENTIFIER]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['++']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{postfix_expression_token});
        %item = (__RULE__ => q{postfix_expression_token});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['++']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\+\+/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['++']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['--']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{postfix_expression_token});
        %item = (__RULE__ => q{postfix_expression_token});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['--']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\-\-/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['--']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{postfix_expression_token},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{postfix_expression_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{postfix_expression_token},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{postfix_expression_token},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::primary_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"primary_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [primary_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{primary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{IDENTIFIER, or constant, or STRING, or '('});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [IDENTIFIER]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{primary_expression});
        %item = (__RULE__ => q{primary_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{primary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{primary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [IDENTIFIER]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [constant]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{primary_expression});
        %item = (__RULE__ => q{primary_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [constant]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{primary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::constant($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [constant]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{primary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [constant]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{constant}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [constant]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [STRING]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{primary_expression});
        %item = (__RULE__ => q{primary_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [STRING]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{primary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::STRING($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [STRING]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{primary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [STRING]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{STRING}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [STRING]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['(' expression ')']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{primary_expression});
        %item = (__RULE__ => q{primary_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{primary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{primary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['(' expression ')']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{primary_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{primary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{primary_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{primary_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::relational_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"relational_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [relational_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{relational_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: shift_expression /(<=|>=|<|>)/ shift_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: shift_expression /(<=|>=|<|>)/ shift_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{relational_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{relational_expression});
        %item = (__RULE__ => q{relational_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: shift_expression /(<=|>=|<|>)/ shift_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{relational_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [shift_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{relational_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{shift_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::shift_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [shift_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{relational_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [shift_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{relational_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{shift_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(<=|>=|<|>)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{relational_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(<=|>=|<|>)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(<=|>=|<|>))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'shift_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [shift_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{relational_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{shift_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::shift_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [shift_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{relational_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [shift_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{relational_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{shift_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: shift_expression /(<=|>=|<|>)/ shift_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{relational_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: shift_expression /(<=|>=|<|>)/ shift_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{relational_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'shift_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: shift_expression /(<=|>=|<|>)/ shift_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{relational_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{relational_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{relational_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{relational_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{relational_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::selection_statement
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"selection_statement"};

    TestParser::_Runtime::_trace(q{Trying rule: [selection_statement]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{selection_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'if', or 'switch'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['if' '(' expression ')' statement 'else']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{selection_statement});
        %item = (__RULE__ => q{selection_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['if']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aif/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'('})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{selection_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{selection_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING3__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{selection_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{statement})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{selection_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: ['else']},
                  TestParser::_Runtime::_tracefirst($text),
                  q{selection_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{'else'})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::_alternation_1_of_production_1_of_rule_selection_statement, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: ['else']>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{selection_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [_alternation_1_of_production_1_of_rule_selection_statement]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule_selection_statement(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: ['if' '(' expression ')' statement 'else']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['switch' '(' expression ')' statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{selection_statement});
        %item = (__RULE__ => q{selection_statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['switch']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aswitch/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'('})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{selection_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{selection_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING3__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{selection_statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{statement})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{selection_statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['switch' '(' expression ')' statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{selection_statement},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{selection_statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{selection_statement},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{selection_statement},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::shift_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"shift_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [shift_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{shift_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: additive_expression /(<<|>>)/ additive_expression>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: additive_expression /(<<|>>)/ additive_expression>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{shift_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{shift_expression});
        %item = (__RULE__ => q{shift_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: additive_expression /(<<|>>)/ additive_expression>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{shift_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [additive_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{shift_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{additive_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::additive_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [additive_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{shift_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [additive_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{shift_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{additive_expression}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(<<|>>)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{shift_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(<<|>>)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(<<|>>))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'additive_expression(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [additive_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{shift_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{additive_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::additive_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [additive_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{shift_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [additive_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{shift_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{additive_expression}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: additive_expression /(<<|>>)/ additive_expression>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{shift_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: additive_expression /(<<|>>)/ additive_expression>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{shift_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'additive_expression(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: additive_expression /(<<|>>)/ additive_expression>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{shift_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{shift_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{shift_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{shift_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{shift_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::specifier_qualifier_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"specifier_qualifier_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [specifier_qualifier_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{specifier_qualifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{type_specifier, or type_qualifier});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [type_specifier specifier_qualifier_list]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{specifier_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{specifier_qualifier_list});
        %item = (__RULE__ => q{specifier_qualifier_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [type_specifier]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{specifier_qualifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::type_specifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [type_specifier]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{specifier_qualifier_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [type_specifier]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{specifier_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type_specifier}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [specifier_qualifier_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{specifier_qualifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{specifier_qualifier_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::specifier_qualifier_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [specifier_qualifier_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{specifier_qualifier_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [specifier_qualifier_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{specifier_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{specifier_qualifier_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [type_specifier specifier_qualifier_list]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{specifier_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [type_qualifier specifier_qualifier_list]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{specifier_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{specifier_qualifier_list});
        %item = (__RULE__ => q{specifier_qualifier_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [type_qualifier]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{specifier_qualifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::type_qualifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [type_qualifier]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{specifier_qualifier_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [type_qualifier]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{specifier_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type_qualifier}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [specifier_qualifier_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{specifier_qualifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{specifier_qualifier_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::specifier_qualifier_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [specifier_qualifier_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{specifier_qualifier_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [specifier_qualifier_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{specifier_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{specifier_qualifier_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [type_qualifier specifier_qualifier_list]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{specifier_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{specifier_qualifier_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{specifier_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{specifier_qualifier_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{specifier_qualifier_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::statement
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"statement"};

    TestParser::_Runtime::_trace(q{Trying rule: [statement]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{statement},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{selection_statement, or expression_statement, or iteration_statement, or compound_statement, or jump_statement, or labeled_statement});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [selection_statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{statement});
        %item = (__RULE__ => q{statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [selection_statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::selection_statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [selection_statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [selection_statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{selection_statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [selection_statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [expression_statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{statement});
        %item = (__RULE__ => q{statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [expression_statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::expression_statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [expression_statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [expression_statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expression_statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [expression_statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [iteration_statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{statement});
        %item = (__RULE__ => q{statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [iteration_statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::iteration_statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [iteration_statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [iteration_statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{iteration_statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [iteration_statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [compound_statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{statement});
        %item = (__RULE__ => q{statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [compound_statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::compound_statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [compound_statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [compound_statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{compound_statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [compound_statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [jump_statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{statement});
        %item = (__RULE__ => q{statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [jump_statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::jump_statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [jump_statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [jump_statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{jump_statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [jump_statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [labeled_statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{statement});
        %item = (__RULE__ => q{statement});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [labeled_statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{statement},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::labeled_statement($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [labeled_statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{statement},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [labeled_statement]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{labeled_statement}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [labeled_statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{statement},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{statement},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{statement},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{statement},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::statement_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"statement_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [statement_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{statement_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{statement});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [statement]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{statement_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{statement_list});
        %item = (__RULE__ => q{statement_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [statement]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{statement_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::statement, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [statement]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{statement_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [statement]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{statement_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{statement(s)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [statement]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{statement_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{statement_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{statement_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{statement_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{statement_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::storage_class_specifier
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"storage_class_specifier"};

    TestParser::_Runtime::_trace(q{Trying rule: [storage_class_specifier]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{storage_class_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'auto', or 'register', or 'static', or 'extern', or 'typedef'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['auto']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{storage_class_specifier});
        %item = (__RULE__ => q{storage_class_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['auto']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aauto/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['auto']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['register']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{storage_class_specifier});
        %item = (__RULE__ => q{storage_class_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['register']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aregister/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['register']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['static']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{storage_class_specifier});
        %item = (__RULE__ => q{storage_class_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['static']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Astatic/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['static']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['extern']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{storage_class_specifier});
        %item = (__RULE__ => q{storage_class_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['extern']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aextern/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['extern']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['typedef']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{storage_class_specifier});
        %item = (__RULE__ => q{storage_class_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['typedef']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Atypedef/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['typedef']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{storage_class_specifier},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{storage_class_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{storage_class_specifier},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{storage_class_specifier},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::struct_declaration
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"struct_declaration"};

    TestParser::_Runtime::_trace(q{Trying rule: [struct_declaration]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{struct_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{specifier_qualifier_list});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [specifier_qualifier_list struct_declarator_list ';']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{struct_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{struct_declaration});
        %item = (__RULE__ => q{struct_declaration});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [specifier_qualifier_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::specifier_qualifier_list($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [specifier_qualifier_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_declaration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [specifier_qualifier_list]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{specifier_qualifier_list}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying subrule: [struct_declarator_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_declaration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{struct_declarator_list})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::struct_declarator_list($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [struct_declarator_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_declaration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [struct_declarator_list]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{struct_declarator_list}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [';']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{';'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\;/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [specifier_qualifier_list struct_declarator_list ';']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{struct_declaration},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{struct_declaration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{struct_declaration},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{struct_declaration},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::struct_declaration_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"struct_declaration_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [struct_declaration_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{struct_declaration_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{struct_declaration});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [struct_declaration]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{struct_declaration_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{struct_declaration_list});
        %item = (__RULE__ => q{struct_declaration_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [struct_declaration]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_declaration_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::struct_declaration, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [struct_declaration]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_declaration_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [struct_declaration]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declaration_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{struct_declaration(s)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [struct_declaration]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declaration_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{struct_declaration_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{struct_declaration_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{struct_declaration_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{struct_declaration_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::struct_declarator
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"struct_declarator"};

    TestParser::_Runtime::_trace(q{Trying rule: [struct_declarator]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{struct_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{declarator});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declarator ':' constant_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{struct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{struct_declarator});
        %item = (__RULE__ => q{struct_declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::declarator, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [declarator]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declarator(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: [':']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{':'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\:/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [constant_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{constant_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::constant_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [constant_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [constant_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{constant_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [declarator ':' constant_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declarator]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{struct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{struct_declarator});
        %item = (__RULE__ => q{struct_declarator});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_declarator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_declarator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declarator}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [declarator]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{struct_declarator},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{struct_declarator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{struct_declarator},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{struct_declarator},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::struct_declarator_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"struct_declarator_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [struct_declarator_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{struct_declarator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{<leftop: struct_declarator /(,)/ struct_declarator>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<leftop: struct_declarator /(,)/ struct_declarator>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{struct_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{struct_declarator_list});
        %item = (__RULE__ => q{struct_declarator_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying operator: [<leftop: struct_declarator /(,)/ struct_declarator>]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_declarator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        TestParser::_Runtime::_trace(q{Trying subrule: [struct_declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_declarator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{struct_declarator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::struct_declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [struct_declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_declarator_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [struct_declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{struct_declarator}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        TestParser::_Runtime::_trace(q{Trying terminal: [/(,)/]}, TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(,)/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(,))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            TestParser::_Runtime::_trace(q{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

            pop @item;
            if (defined $1) {push @item, $item{'struct_declarator(s)'}=$1; $backtrack=1;}
            
        TestParser::_Runtime::_trace(q{Trying subrule: [struct_declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_declarator_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{struct_declarator})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::struct_declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [struct_declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_declarator_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [struct_declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{struct_declarator}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match operator: [<leftop: struct_declarator /(,)/ struct_declarator>]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_declarator_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched operator: [<leftop: struct_declarator /(,)/ struct_declarator>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{'struct_declarator(s)'}=$_tok||[];

        TestParser::_Runtime::_trace(q{>>Matched production: [<leftop: struct_declarator /(,)/ struct_declarator>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{struct_declarator_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{struct_declarator_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{struct_declarator_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{struct_declarator_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::struct_or_union
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"struct_or_union"};

    TestParser::_Runtime::_trace(q{Trying rule: [struct_or_union]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{struct_or_union},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'struct', or 'union'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['struct']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{struct_or_union},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{struct_or_union});
        %item = (__RULE__ => q{struct_or_union});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['struct']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Astruct/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['struct']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['union']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{struct_or_union},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{struct_or_union});
        %item = (__RULE__ => q{struct_or_union});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['union']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aunion/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['union']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{struct_or_union},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{struct_or_union},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{struct_or_union},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{struct_or_union},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::struct_or_union_specifier
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"struct_or_union_specifier"};

    TestParser::_Runtime::_trace(q{Trying rule: [struct_or_union_specifier]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{struct_or_union_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{struct_or_union});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [struct_or_union IDENTIFIER '\{' struct_declaration_list '\}']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{struct_or_union_specifier});
        %item = (__RULE__ => q{struct_or_union_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [struct_or_union]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_or_union_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::struct_or_union($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [struct_or_union]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_or_union_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [struct_or_union]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{struct_or_union}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_or_union_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{IDENTIFIER})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::IDENTIFIER, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_or_union_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [IDENTIFIER]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: ['\{']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'\{'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\{/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [struct_declaration_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_or_union_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{struct_declaration_list})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::struct_declaration_list, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [struct_declaration_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_or_union_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [struct_declaration_list]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{struct_declaration_list(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{Trying terminal: ['\}']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'\}'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\}/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying action},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
            if($::opt_STRUCTS){
                $::structs_output .= ::flatten_list($item[1]) . " ";
                $::structs_output .= ::flatten_list($item[2]);
                $::structs_output .= ::flatten_list($item[3]) . "\n";
                $::structs_output .= ::flatten_list_beautified($item[4]);
                $::structs_output .= ::flatten_list($item[5]) . ";\n\n";
            }
          };
        unless (defined $_tok)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      TestParser::_Runtime::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [struct_or_union IDENTIFIER '\{' struct_declaration_list '\}']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [struct_or_union IDENTIFIER]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{struct_or_union_specifier});
        %item = (__RULE__ => q{struct_or_union_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [struct_or_union]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_or_union_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::struct_or_union($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [struct_or_union]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_or_union_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [struct_or_union]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{struct_or_union}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{struct_or_union_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{IDENTIFIER})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{struct_or_union_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [struct_or_union IDENTIFIER]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{struct_or_union_specifier},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{struct_or_union_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{struct_or_union_specifier},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{struct_or_union_specifier},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::translation_unit
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"translation_unit"};

    TestParser::_Runtime::_trace(q{Trying rule: [translation_unit]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{translation_unit},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{external_declaration});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [external_declaration]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{translation_unit},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{translation_unit});
        %item = (__RULE__ => q{translation_unit});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [external_declaration]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{translation_unit},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::external_declaration, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [external_declaration]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{translation_unit},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [external_declaration]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{translation_unit},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{external_declaration(s)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [external_declaration]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{translation_unit},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [<error...>]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{translation_unit},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{translation_unit});
        %item = (__RULE__ => q{translation_unit});
        my $repcount = 0;


        

        TestParser::_Runtime::_trace(q{Trying directive: [<error...>]},
                    TestParser::_Runtime::_tracefirst($text),
                      q{translation_unit},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: TestParser::_Runtime::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            TestParser::_Runtime::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            TestParser::_Runtime::_trace(q{<<Didn't match directive>>},
                        TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [<error...>]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{translation_unit},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{translation_unit},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{translation_unit},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{translation_unit},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{translation_unit},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::type_name
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"type_name"};

    TestParser::_Runtime::_trace(q{Trying rule: [type_name]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{type_name},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{specifier_qualifier_list});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [specifier_qualifier_list abstract_declarator]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_name});
        %item = (__RULE__ => q{type_name});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [specifier_qualifier_list]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{type_name},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::specifier_qualifier_list($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [specifier_qualifier_list]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{type_name},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [specifier_qualifier_list]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{type_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{specifier_qualifier_list}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying repeated subrule: [abstract_declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{type_name},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{abstract_declarator})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::abstract_declarator, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [abstract_declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{type_name},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [abstract_declarator]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{type_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{abstract_declarator(?)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [specifier_qualifier_list abstract_declarator]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_name},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{type_name},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{type_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{type_name},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{type_name},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::type_qualifier
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"type_qualifier"};

    TestParser::_Runtime::_trace(q{Trying rule: [type_qualifier]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{type_qualifier},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'const', or 'volatile'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['const']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_qualifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_qualifier});
        %item = (__RULE__ => q{type_qualifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['const']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_qualifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aconst/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['const']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_qualifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['volatile']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_qualifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_qualifier});
        %item = (__RULE__ => q{type_qualifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['volatile']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_qualifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Avolatile/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['volatile']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_qualifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{type_qualifier},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{type_qualifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{type_qualifier},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{type_qualifier},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::type_qualifier_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"type_qualifier_list"};

    TestParser::_Runtime::_trace(q{Trying rule: [type_qualifier_list]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{type_qualifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{type_qualifier});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [type_qualifier]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_qualifier_list});
        %item = (__RULE__ => q{type_qualifier_list});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying repeated subrule: [type_qualifier]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{type_qualifier_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&TestParser::_Runtime::TestParser::type_qualifier, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            TestParser::_Runtime::_trace(q{<<Didn't match repeated subrule: [type_qualifier]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{type_qualifier_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched repeated subrule: [type_qualifier]<< (}
                    . @$_tok . q{ times)},

                      TestParser::_Runtime::_tracefirst($text),
                      q{type_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type_qualifier(s)}} = $_tok;
        push @item, $_tok;
        


        TestParser::_Runtime::_trace(q{>>Matched production: [type_qualifier]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{type_qualifier_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{type_qualifier_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{type_qualifier_list},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{type_qualifier_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::type_specifier
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"type_specifier"};

    TestParser::_Runtime::_trace(q{Trying rule: [type_specifier]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{type_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{'int', or 'double', or 'void', or 'char', or 'long', or 'float', or 'signed', or 'unsigned', or 'short', or struct_or_union_specifier, or enum_specifier, or typedef_name});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['int']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['int']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aint/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['int']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['double']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['double']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Adouble/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['double']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['void']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['void']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Avoid/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['void']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['char']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['char']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Achar/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['char']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['long']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['long']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Along/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['long']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['float']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['float']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Afloat/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['float']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['signed']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[6];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['signed']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Asigned/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['signed']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['unsigned']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[7];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['unsigned']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Aunsigned/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['unsigned']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['short']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[8];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['short']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Ashort/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['short']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [struct_or_union_specifier]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[9];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [struct_or_union_specifier]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{type_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::struct_or_union_specifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [struct_or_union_specifier]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{type_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [struct_or_union_specifier]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{struct_or_union_specifier}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [struct_or_union_specifier]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [enum_specifier]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[10];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [enum_specifier]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{type_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::enum_specifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [enum_specifier]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{type_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [enum_specifier]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{enum_specifier}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [enum_specifier]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [typedef_name typedef_name_lookahead]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[11];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_specifier});
        %item = (__RULE__ => q{type_specifier});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [typedef_name]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{type_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::typedef_name($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [typedef_name]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{type_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [typedef_name]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{typedef_name}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying subrule: [typedef_name_lookahead]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{type_specifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{typedef_name_lookahead})->at($text);
        $_savetext = $text;unless (defined ($_tok = TestParser::_Runtime::TestParser::typedef_name_lookahead($thisparser,$text,$repeating,1,sub { \@arg },undef)))
        {
            $text = $_savetext;
            TestParser::_Runtime::_trace(q{<<...Didn't match(reject) subrule: [typedef_name_lookahead]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{type_specifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>...Matched(keep) subrule: [typedef_name_lookahead]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{typedef_name_lookahead}} = $_tok;
        push @item, $_tok;
        $text = $_savetext;
        }

        TestParser::_Runtime::_trace(q{Trying action},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { [$item[1] ] };
        unless (defined $_tok)
        {
            TestParser::_Runtime::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      TestParser::_Runtime::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        TestParser::_Runtime::_trace(q{>>Matched production: [typedef_name typedef_name_lookahead]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{type_specifier},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{type_specifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{type_specifier},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{type_specifier},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::typedef_name
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"typedef_name"};

    TestParser::_Runtime::_trace(q{Trying rule: [typedef_name]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{typedef_name},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{IDENTIFIER});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [IDENTIFIER]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{typedef_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{typedef_name});
        %item = (__RULE__ => q{typedef_name});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [IDENTIFIER]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{typedef_name},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::IDENTIFIER($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [IDENTIFIER]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{typedef_name},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [IDENTIFIER]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{typedef_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{IDENTIFIER}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [IDENTIFIER]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{typedef_name},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{typedef_name},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{typedef_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{typedef_name},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{typedef_name},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::typedef_name_lookahead
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"typedef_name_lookahead"};

    TestParser::_Runtime::_trace(q{Trying rule: [typedef_name_lookahead]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{typedef_name_lookahead},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{declarator});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [declarator]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{typedef_name_lookahead},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{typedef_name_lookahead});
        %item = (__RULE__ => q{typedef_name_lookahead});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [declarator]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{typedef_name_lookahead},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::declarator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [declarator]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{typedef_name_lookahead},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [declarator]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{typedef_name_lookahead},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{declarator}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [declarator]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{typedef_name_lookahead},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{typedef_name_lookahead},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{typedef_name_lookahead},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{typedef_name_lookahead},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{typedef_name_lookahead},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub TestParser::_Runtime::TestParser::unary_expression
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"unary_expression"};

    TestParser::_Runtime::_trace(q{Trying rule: [unary_expression]},
                  TestParser::_Runtime::_tracefirst($_[1]),
                  q{unary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new TestParser::_Runtime::Expectation(q{postfix_expression, or '++', or '--', or 'sizeof', or UNARY_OPERATOR});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{TestParser::_Runtime::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [postfix_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{unary_expression});
        %item = (__RULE__ => q{unary_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [postfix_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{unary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::postfix_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [postfix_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{unary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [postfix_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{postfix_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [postfix_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['++' unary_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{unary_expression});
        %item = (__RULE__ => q{unary_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['++']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\+\+/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [unary_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{unary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{unary_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::unary_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [unary_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{unary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [unary_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{unary_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['++' unary_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['--' unary_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{unary_expression});
        %item = (__RULE__ => q{unary_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['--']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\-\-/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [unary_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{unary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{unary_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::unary_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [unary_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{unary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [unary_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{unary_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['--' unary_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['sizeof' '(' type_name ')']},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{unary_expression});
        %item = (__RULE__ => q{unary_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['sizeof']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Asizeof/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying terminal: ['(']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'('})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\(/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [type_name]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{unary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{type_name})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::type_name($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [type_name]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{unary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [type_name]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type_name}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying terminal: [')']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{')'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING3__}=$current_match;
        

        TestParser::_Runtime::_trace(q{>>Matched production: ['sizeof' '(' type_name ')']<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: [UNARY_OPERATOR cast_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{unary_expression});
        %item = (__RULE__ => q{unary_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying subrule: [UNARY_OPERATOR]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{unary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::UNARY_OPERATOR($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [UNARY_OPERATOR]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{unary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [UNARY_OPERATOR]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{UNARY_OPERATOR}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{Trying subrule: [cast_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{unary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{cast_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::cast_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [cast_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{unary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [cast_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{cast_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: [UNARY_OPERATOR cast_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        TestParser::_Runtime::_trace(q{Trying production: ['sizeof' unary_expression]},
                      TestParser::_Runtime::_tracefirst($_[1]),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{unary_expression});
        %item = (__RULE__ => q{unary_expression});
        my $repcount = 0;


        TestParser::_Runtime::_trace(q{Trying terminal: ['sizeof']},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\Asizeof/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            TestParser::_Runtime::_trace(qq{<<Didn't match terminal>>},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        TestParser::_Runtime::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          TestParser::_Runtime::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        TestParser::_Runtime::_trace(q{Trying subrule: [unary_expression]},
                  TestParser::_Runtime::_tracefirst($text),
                  q{unary_expression},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{unary_expression})->at($text);
        unless (defined ($_tok = TestParser::_Runtime::TestParser::unary_expression($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            TestParser::_Runtime::_trace(q{<<Didn't match subrule: [unary_expression]>>},
                          TestParser::_Runtime::_tracefirst($text),
                          q{unary_expression},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        TestParser::_Runtime::_trace(q{>>Matched subrule: [unary_expression]<< (return value: [}
                    . $_tok . q{]},

                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{unary_expression}} = $_tok;
        push @item, $_tok;
        
        }

        TestParser::_Runtime::_trace(q{>>Matched production: ['sizeof' unary_expression]<<},
                      TestParser::_Runtime::_tracefirst($text),
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        TestParser::_Runtime::_trace(q{<<Didn't match rule>>},
                     TestParser::_Runtime::_tracefirst($_[1]),
                     q{unary_expression},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        TestParser::_Runtime::_trace(q{>>Accepted scored production<<}, "",
                      q{unary_expression},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        TestParser::_Runtime::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{unary_expression},
                      $tracelevel);
        TestParser::_Runtime::_trace(q{(consumed: [} .
                      TestParser::_Runtime::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      TestParser::_Runtime::_tracefirst($text),
                      , q{unary_expression},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}
}
package TestParser; sub new { my 